# SPIM S20 MIPS simulator.
# The default trap handler for spim.
#
# Copyright (C) 1990-1995 James Larus, larus@cs.wisc.edu.
# ALL RIGHTS RESERVED.
#
# SPIM is distributed under the following conditions:
#
# You may make copies of SPIM for your own use and modify those copies.
#
# All copies of SPIM must retain my name and copyright notice.
#
# You may not sell SPIM or distributed SPIM in conjunction with a commerical
# product or service without the expressed written consent of James Larus.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE.
#

# $Header: /u/l/a/larus/Software/SPIM/src/RCS/trap.handler,v 1.23 1997/07/09 21:45:23 larus Exp $


# Define the exception handling code.  This must go first!

	.kdata
__m1_:	.asciiz "  Exception "
__m2_:	.asciiz " occurred and ignored\n"
__e0_:	.asciiz "  [Interrupt] "
__e1_:	.asciiz	""
__e2_:	.asciiz	""
__e3_:	.asciiz	""
__e4_:	.asciiz	"  [Unaligned address in inst/data fetch] "
__e5_:	.asciiz	"  [Unaligned address in store] "
__e6_:	.asciiz	"  [Bad address in text read] "
__e7_:	.asciiz	"  [Bad address in data/stack read] "
__e8_:	.asciiz	"  [Error in syscall] "
__e9_:	.asciiz	"  [Breakpoint] "
__e10_:	.asciiz	"  [Reserved instruction] "
__e11_:	.asciiz	""
__e12_:	.asciiz	"  [Arithmetic overflow] "
__e13_:	.asciiz	"  [Inexact floating point result] "
__e14_:	.asciiz	"  [Invalid floating point result] "
__e15_:	.asciiz	"  [Divide by 0] "
__e16_:	.asciiz	"  [Floating point overflow] "
__e17_:	.asciiz	"  [Floating point underflow] "
__excp:	.word __e0_,__e1_,__e2_,__e3_,__e4_,__e5_,__e6_,__e7_,__e8_,__e9_
	.word __e10_,__e11_,__e12_,__e13_,__e14_,__e15_,__e16_,__e17_
s1:	.word 0
s2:	.word 0
g1: .word 0x12345678
g2: .word 0x87654321

	.ktext 0x80000080
	.set noat
	# Because we are running in the kernel, we can use $k0/$k1 without
	# saving their old values.
	move $k1 $at	# Save $at
	.set at
	sw $v0 s1	# Not re-entrent and we can't trust $sp
	sw $a0 s2
	mfc0 $k0 $13	# Cause
        sgt $v0 $k0 0x44 # ignore interrupt exceptions
        bgtz $v0 ret
        addu $0 $0 0
	li $v0 4	# syscall 4 (print_str)
	la $a0 __m1_
	syscall
	li $v0 1	# syscall 1 (print_int)
        srl $a0 $k0 2	# shift Cause reg
	syscall
	li $v0 4	# syscall 4 (print_str)
	lw $a0 __excp($k0)
	syscall
	bne $k0 0x18 ok_pc # Bad PC requires special checks
	mfc0 $a0, $14	# EPC
	and $a0, $a0, 0x3 # Is EPC word-aligned?
	beq $a0, 0, ok_pc
	li $v0 10	# Exit on really bad PC (out of text)
	syscall

ok_pc:
	li $v0 4	# syscall 4 (print_str)
	la $a0 __m2_
	syscall
	mtc0 $0, $13	# Clear Cause register
ret:	lw $v0 s1
	lw $a0 s2
	mfc0 $k0 $14	# EPC
	.set noat
	move $at $k1	# Restore $at
	.set at
	rfe		# Return from exception handler
	addiu $k0 $k0 4 # Return to next instruction
	jr $k0


# Standard startup code.  Invoke the routine main with no arguments.

	.text
	.globl __start
__start: 
	lw $a0, 0($sp)	# argc
	addiu $a1, $sp, 4 # argv
	addiu $a2, $a1, 4 # envp
	sll $v0, $a0, 2
	addu $a2, $a2, $v0
	jal main
	li $v0 10
	syscall		# syscall 10 (exit)


# Utilities

	.text
	.globl _putchar
_putchar:
	la	$a1,0xffff0008
	lw	$a1,0($a1)
	andi	$a1,1
	beqz	$a1,_putchar
	la	$a1,0xffff000c
	sw	$a0,0($a1)
	jr	$31
	nop

# Signed multiply subroutine
# $2(x) * $3(y) -> $2
# $1..$5 destroyed
	.text
	.globl	__smuls
# $1: loop counter
# $4: temp
# $5: product
	.set	noat
__smuls:
	subu	$sp,16
	sw		$1,4($sp)
	sw		$4,8($sp)
	sw		$5,12($sp)
	li	$5,0		# z = 0
	li	$1,30		# init. loop counter
	sra	$4,$3,31
	bne	$4,$0,__smul1x	# if y.msb==1 then goto __smul1x
	nop
__smul0x:
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul01	# if y.msb==1 then goto Case01
	nop
__smul00:			# Case00
	sll	$5,$5,1		# z = z << 1
	beq	$1,$0,__smulend	# if loop end
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	beq	$4,$0,__smul00	# if y.msb==0 then goto Case00
	nop
__smul01:			# Case01
	add	$5,$5,$2
	sll	$5,$5,1		# z = (z + x) << 1
	beq	$1,$0,__smulend	# if loop end
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul11	# if y.msb==0 then goto Case11
	nop
__smul10:			# Case10
	sub	$5,$5,$2
	sll	$5,$5,1		# z = (z - x) << 1
	beq	$1,$0,__smulend	# if loop end
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31	# if y.msb==1 then goto Case01
	bne	$4,$0,__smul01
	nop
	beq	$4,$0,__smul00	# else goto Case00
	nop
__smul1x:
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	beq	$4,$0,__smul10	# else goto Case10
	nop
__smul11:			# Case11
	sll	$5,$5,1		# z = z << 1
	beq	$1,$0,__smulend	# if loop end
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul11	# if y.msb==1 then goto Case11
	nop
	beq	$4,$0,__smul10	# else goto Case10
	nop
__smulend:
	sra	$4,$3,31
	and	$2,$2,$4
	sub	$2,$5,$2	# if y.msb==1 then z = z - x (10 pattern)
	lw		$1,4($sp)
	lw		$4,8($sp)
	lw		$5,12($sp)
	addu	$sp,16
	jr	$31
	nop

# Signed division subroutine
# $2 / $3 -> $2(quotient), $3(remainder)
# $1..$6 destroyed
	.text
	.globl	__sdivs
# $1: loop counter
# $2: remainder      r
# $3: divident       x
# $4: temp
# $5: quotient       q
# $6: temp(saved $2) w
# $7: ww
	.set	noat
__sdivs:
	subu	$sp,24
	sw	$1,4($sp)
	sw	$4,8($sp)
	sw	$5,12($sp)
	sw	$6,16($sp)
	sw	$7,20($sp)
	li	$5,0		# q = 0
	add	$6,$2,$0	# save
	add	$7,$2,$0	# setup ww
	sra	$2,$2,31	# setup r (sign extension)
	li	$1,32		# setup loop counter
__sdiv1:
	and	$4,$2,$3
	sra	$4,$4,31	# MSB extension
	bne	$4,$0,__sdiv2	# r < 0 & x < 0
	nop
	or	$4,$2,$3
	sra	$4,$4,31	# MSB extension
	beq	$4,$0,__sdiv2	# r >= 0 & x >= 0
	nop
# r < 0 & x >= 0 | r >= 0 & x < 0
	sll	$2,$2,1		# r = r << 1
	sra	$4,$7,31
	sub	$2,$2,$4	# if ww.msb==1 then r = r + 1
#__sdiv5:
	sll	$7,$7,1		# ww = ww << 1
	add	$2,$2,$3	# r = r - x
	sll	$5,$5,1
	addi	$5,$5,-1	# q = (q << 1) - 1
	b	__sdiv4
	nop
# r < 0 & x < 0 | r >= 0 & x >= 0
__sdiv2:
	sll	$2,$2,1		# r = r << 1
	sra	$4,$7,31
	sub	$2,$2,$4	# if ww.msb==1 then r = r + 1
#__sdiv3:
	sll	$7,$7,1		# ww = ww << 1
	sub	$2,$2,$3	# r = r - x
	sll	$5,$5,1
	addi	$5,$5,1		# q = (q << 1) + 1
__sdiv4:
	addi	$1,$1,-1	# next loop
	bne	$1,$0,__sdiv1	# loop end
	nop

# adustment phase
	beq	$2,$0,__sdivadjn	# r == 0
	nop

	sra	$4,$2,31
	beq	$4,$0,__sdivadj1		# r >= 0
	nop
	sra	$4,$6,31
	bne	$4,$0,__sdivadj2		# w < 0
	nop
	sra	$4,$3,31
	beq	$4,$0,__sdivadjm		# x >= 0
	nop
__sdivadjp:
# r = r - x; q = q + 1
	sub	$3,$2,$3
	addiu	$2,$5,1
	b	__sdivend
	nop
__sdivadj1:
	sra	$4,$6,31
	beq	$4,$0,__sdivadjn		# w >= 0
	sra	$4,$3,31
	bne	$4,$0,__sdivadjn		# x < 0
	nop
__sdivadj2:
	beq	$2,$3,__sdivadjp		# r == x
	nop
	sub	$4,$2,$3
	bne	$4,$0,__sdivadjn		# r != -x
	nop
__sdivadjm:
# r = r + x; q = q - 1
	add	$3,$2,$3
	addi	$2,$5,-1
	b	__sdivend
	nop
__sdivadjn:
# nothing
	add	$3,$2,$0
	add	$2,$5,$0
__sdivend:
	lw	$1,4($sp)
	lw	$4,8($sp)
	lw	$5,12($sp)
	lw	$6,16($sp)
	lw	$7,20($sp)
	addu	$sp,24
	jr	$31
	nop
