# Signed multiply subroutine
# $2(x) * $3(y) -> $2
# $1..$5 destroyed
	.text
	.globl	__smuls
# $1: loop counter
# $4: temp
# $5: product
	.set	noat
__smuls:
	subu	$sp,16
	sw		$1,4($sp)
	sw		$4,8($sp)
	sw		$5,12($sp)
	li	$5,0		# z = 0
	li	$1,30		# init. loop counter
	sra	$4,$3,31
	bne	$4,$0,__smul1x	# if y.msb==1 then goto __smul1x
	nop
__smul0x:
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul01	# if y.msb==1 then goto Case01
	nop
__smul00:			# Case00
	sll	$5,$5,1		# z = z << 1
	beq	$1,$0,__smulend	# if loop end
	nop
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	beq	$4,$0,__smul00	# if y.msb==0 then goto Case00
	nop
__smul01:			# Case01
	add	$5,$5,$2
	sll	$5,$5,1		# z = (z + x) << 1
	beq	$1,$0,__smulend	# if loop end
	nop
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul11	# if y.msb==0 then goto Case11
	nop
__smul10:			# Case10
	sub	$5,$5,$2
	sll	$5,$5,1		# z = (z - x) << 1
	beq	$1,$0,__smulend	# if loop end
	nop
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31	# if y.msb==1 then goto Case01
	bne	$4,$0,__smul01
	nop
	beq	$4,$0,__smul00	# else goto Case00
	nop
__smul1x:
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	beq	$4,$0,__smul10	# else goto Case10
	nop
__smul11:			# Case11
	sll	$5,$5,1		# z = z << 1
	beq	$1,$0,__smulend	# if loop end
	nop
	subu	$1,$1,1		# next loop
	sll	$3,$3,1		# y = y << 1
	sra	$4,$3,31
	bne	$4,$0,__smul11	# if y.msb==1 then goto Case11
	nop
	beq	$4,$0,__smul10	# else goto Case10
	nop
__smulend:
	sra	$4,$3,31
	and	$2,$2,$4
	sub	$2,$5,$2	# if y.msb==1 then z = z - x (10 pattern)
	lw		$1,4($sp)
	lw		$4,8($sp)
	lw		$5,12($sp)
	addu	$sp,16
	jr	$31
	nop

# Signed division subroutine
# $2 / $3 -> $2(quotient), $3(remainder)
# $1..$6 destroyed
	.text
	.globl	__sdivs
# $1: loop counter
# $2: remainder      r
# $3: divident       x
# $4: temp
# $5: quotient       q
# $6: temp(saved $2) w
# $7: ww
	.set	noat
__sdivs:
	subu	$sp,24
	sw	$1,4($sp)
	sw	$4,8($sp)
	sw	$5,12($sp)
	sw	$6,16($sp)
	sw	$7,20($sp)
	li	$5,0		# q = 0
	add	$6,$2,$0	# save
	add	$7,$2,$0	# setup ww
	sra	$2,$2,31	# setup r (sign extension)
	li	$1,32		# setup loop counter
__sdiv1:
	and	$4,$2,$3
	sra	$4,$4,31	# MSB extension
	bne	$4,$0,__sdiv2	# r < 0 & x < 0
	nop
	or	$4,$2,$3
	sra	$4,$4,31	# MSB extension
	beq	$4,$0,__sdiv2	# r >= 0 & x >= 0
	nop
# r < 0 & x >= 0 | r >= 0 & x < 0
	sll	$2,$2,1		# r = r << 1
	sra	$4,$7,31
	sub	$2,$2,$4	# if ww.msb==1 then r = r + 1
#__sdiv5:
	sll	$7,$7,1		# ww = ww << 1
	add	$2,$2,$3	# r = r - x
	sll	$5,$5,1
	addi	$5,$5,-1	# q = (q << 1) - 1
	b	__sdiv4
	nop
# r < 0 & x < 0 | r >= 0 & x >= 0
__sdiv2:
	sll	$2,$2,1		# r = r << 1
	sra	$4,$7,31
	sub	$2,$2,$4	# if ww.msb==1 then r = r + 1
#__sdiv3:
	sll	$7,$7,1		# ww = ww << 1
	sub	$2,$2,$3	# r = r - x
	sll	$5,$5,1
	addi	$5,$5,1		# q = (q << 1) + 1
__sdiv4:
	addi	$1,$1,-1	# next loop
	bne	$1,$0,__sdiv1	# loop end
	nop

# adustment phase
	beq	$2,$0,__sdivadjn	# r == 0
	nop

	sra	$4,$2,31
	beq	$4,$0,__sdivadj1		# r >= 0
	nop
	sra	$4,$6,31
	bne	$4,$0,__sdivadj2		# w < 0
	nop
	sra	$4,$3,31
	beq	$4,$0,__sdivadjm		# x >= 0
	nop
__sdivadjp:
# r = r - x; q = q + 1
	sub	$3,$2,$3
	addiu	$2,$5,1
	b	__sdivend
	nop
__sdivadj1:
	sra	$4,$6,31
	beq	$4,$0,__sdivadjn		# w >= 0
	nop
	sra	$4,$3,31
	bne	$4,$0,__sdivadjn		# x < 0
	nop
__sdivadj2:
	beq	$2,$3,__sdivadjp		# r == x
	nop
	sub	$4,$2,$3
	bne	$4,$0,__sdivadjn		# r != -x
	nop
__sdivadjm:
# r = r + x; q = q - 1
	add	$3,$2,$3
	addi	$2,$5,-1
	b	__sdivend
	nop
__sdivadjn:
# nothing
	add	$3,$2,$0
	add	$2,$5,$0
__sdivend:
	lw	$1,4($sp)
	lw	$4,8($sp)
	lw	$5,12($sp)
	lw	$6,16($sp)
	lw	$7,20($sp)
	addu	$sp,24
	jr	$31
	nop
