#if defined(__STDC__) || defined(__cplusplus)
#define YYCONST const
#define YYPARAMS(x) x
#define YYDEFUN(name, arglist, args) name(args)
#define YYAND ,
#define YYPTR void *
#else
#define YYCONST
#define YYPARAMS(x) ()
#define YYDEFUN(name, arglist, args) name arglist args;
#define YYAND ;
#define YYPTR char *
#endif
#ifndef lint
YYCONST static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley +Cygnus.28) 01/20/91";
#endif
#define YYBYACC 1
#ifndef YYDONT_INCLUDE_STDIO
#include <stdio.h>
#endif
#ifdef __cplusplus
#include <stdlib.h> /* for malloc/realloc/free */
#endif
#line 294 "parser.y"
#include <stdio.h>

#include "spim.h"
#include "spim-utils.h"
#include "inst.h"
#include "mem.h"
#include "reg.h"
#include "sym-tbl.h"
#include "data.h"
#include "scanner.h"
#include "parser.h"


/* return (0) */
#define LINE_PARSE_DONE YYACCEPT

/* return (1) */
#define FILE_PARSE_DONE YYABORT

typedef struct ll
{
  label *head;
  struct ll *tail;
} label_list;


/* Exported Variables: */

int data_dir;			/* Non-zero means item in data segment */

int text_dir;			/* Non-zero means item in text segment */

int parse_error_occurred;  /* Non-zero => parse resulted in error */


/* Local functions: */

#ifdef __STDC__
static imm_expr *branch_offset (int n_inst);
static void check_imm_range (imm_expr*, int32, int32);
static void check_uimm_range (imm_expr*, uint32, uint32);
static void clear_labels (void);
static label_list *cons_label (label *head, label_list *tail);
static void div_inst (int op, int rd, int rs, int rt, int const_divisor);
static void mult_inst (int op, int rd, int rs, int rt);
static void nop_inst (void);
static void set_eq_inst (int op, int rd, int rs, int rt);
static void set_ge_inst (int op, int rd, int rs, int rt);
static void set_gt_inst (int op, int rd, int rs, int rt);
static void set_le_inst (int op, int rd, int rs, int rt);
static void store_word_data (int value);
static void trap_inst (void);
static void yywarn (char*);
#else
static imm_expr *branch_offset ();
static void check_imm_range();
static void check_uimm_range();
static void clear_labels ();
static label_list *cons_label ();
static void div_inst ();
static void mult_inst ();
static void nop_inst ();
static void set_eq_inst ();
static void set_ge_inst ();
static void set_gt_inst ();
static void set_le_inst ();
static void store_word_data ();
static void trap_inst ();
static void yywarn ();
#endif


/* Local variables: */

static int null_term;		/* Non-zero means string terminate by \0 */

static void (*store_op) ();	/* Function to store items in an EXPR_LST */

static label_list *this_line_labels = NULL; /* List of label for curent line */

static int noat_flag = 0;	/* Non-zero means program can use $1 */

static char *input_file_name;	/* Name of file being parsed */

#line 110 "y.tab.c"
#define Y_EOF 257
#define Y_NL 258
#define Y_INT 259
#define Y_ID 260
#define Y_REG 261
#define Y_FP_REG 262
#define Y_STR 263
#define Y_FP 264
#define Y_ABS_D_OP 265
#define Y_ABS_S_OP 266
#define Y_ADDIU_OP 267
#define Y_ADDI_OP 268
#define Y_ADDU_OP 269
#define Y_ADD_D_OP 270
#define Y_ADD_OP 271
#define Y_ADD_S_OP 272
#define Y_ANDI_OP 273
#define Y_AND_OP 274
#define Y_BC0F_OP 275
#define Y_BC0T_OP 276
#define Y_BC1F_OP 277
#define Y_BC1T_OP 278
#define Y_BC2F_OP 279
#define Y_BC2T_OP 280
#define Y_BC3F_OP 281
#define Y_BC3T_OP 282
#define Y_BEQ_OP 283
#define Y_BGEZAL_OP 284
#define Y_BGEZ_OP 285
#define Y_BGTZ_OP 286
#define Y_BLEZ_OP 287
#define Y_BLTZAL_OP 288
#define Y_BLTZ_OP 289
#define Y_BNE_OP 290
#define Y_BREAK_OP 291
#define Y_CFC0_OP 292
#define Y_CFC1_OP 293
#define Y_CFC2_OP 294
#define Y_CFC3_OP 295
#define Y_COP0_OP 296
#define Y_COP1_OP 297
#define Y_COP2_OP 298
#define Y_COP3_OP 299
#define Y_CTC0_OP 300
#define Y_CTC1_OP 301
#define Y_CTC2_OP 302
#define Y_CTC3_OP 303
#define Y_CVT_D_S_OP 304
#define Y_CVT_D_W_OP 305
#define Y_CVT_S_D_OP 306
#define Y_CVT_S_W_OP 307
#define Y_CVT_W_D_OP 308
#define Y_CVT_W_S_OP 309
#define Y_C_EQ_D_OP 310
#define Y_C_EQ_S_OP 311
#define Y_C_F_D_OP 312
#define Y_C_F_S_OP 313
#define Y_C_LE_D_OP 314
#define Y_C_LE_S_OP 315
#define Y_C_LT_D_OP 316
#define Y_C_LT_S_OP 317
#define Y_C_NGE_D_OP 318
#define Y_C_NGE_S_OP 319
#define Y_C_NGLE_D_OP 320
#define Y_C_NGLE_S_OP 321
#define Y_C_NGL_D_OP 322
#define Y_C_NGL_S_OP 323
#define Y_C_NGT_D_OP 324
#define Y_C_NGT_S_OP 325
#define Y_C_OLT_D_OP 326
#define Y_C_OLT_S_OP 327
#define Y_C_OLE_D_OP 328
#define Y_C_OLE_S_OP 329
#define Y_C_SEQ_D_OP 330
#define Y_C_SEQ_S_OP 331
#define Y_C_SF_D_OP 332
#define Y_C_SF_S_OP 333
#define Y_C_UEQ_D_OP 334
#define Y_C_UEQ_S_OP 335
#define Y_C_ULT_D_OP 336
#define Y_C_ULT_S_OP 337
#define Y_C_ULE_D_OP 338
#define Y_C_ULE_S_OP 339
#define Y_C_UN_D_OP 340
#define Y_C_UN_S_OP 341
#define Y_DIVU_OP 342
#define Y_DIV_D_OP 343
#define Y_DIV_OP 344
#define Y_DIV_S_OP 345
#define Y_JALR_OP 346
#define Y_JAL_OP 347
#define Y_JR_OP 348
#define Y_J_OP 349
#define Y_LBU_OP 350
#define Y_LB_OP 351
#define Y_LHU_OP 352
#define Y_LH_OP 353
#define Y_LUI_OP 354
#define Y_LWC0_OP 355
#define Y_LWC1_OP 356
#define Y_LWC2_OP 357
#define Y_LWC3_OP 358
#define Y_LWL_OP 359
#define Y_LWR_OP 360
#define Y_LW_OP 361
#define Y_MFC0_OP 362
#define Y_MFC1_OP 363
#define Y_MFC2_OP 364
#define Y_MFC3_OP 365
#define Y_MFHI_OP 366
#define Y_MFLO_OP 367
#define Y_MOV_D_OP 368
#define Y_MOV_S_OP 369
#define Y_MTC0_OP 370
#define Y_MTC1_OP 371
#define Y_MTC2_OP 372
#define Y_MTC3_OP 373
#define Y_MTHI_OP 374
#define Y_MTLO_OP 375
#define Y_MULTU_OP 376
#define Y_MULT_OP 377
#define Y_MUL_D_OP 378
#define Y_MUL_S_OP 379
#define Y_NEG_D_OP 380
#define Y_NEG_S_OP 381
#define Y_NOR_OP 382
#define Y_ORI_OP 383
#define Y_OR_OP 384
#define Y_PFW_OP 385
#define Y_RFE_OP 386
#define Y_SB_OP 387
#define Y_SH_OP 388
#define Y_SLLV_OP 389
#define Y_SLL_OP 390
#define Y_SLTIU_OP 391
#define Y_SLTI_OP 392
#define Y_SLTU_OP 393
#define Y_SLT_OP 394
#define Y_SRAV_OP 395
#define Y_SRA_OP 396
#define Y_SRLV_OP 397
#define Y_SRL_OP 398
#define Y_SUBU_OP 399
#define Y_SUB_D_OP 400
#define Y_SUB_OP 401
#define Y_SUB_S_OP 402
#define Y_SWC0_OP 403
#define Y_SWC1_OP 404
#define Y_SWC2_OP 405
#define Y_SWC3_OP 406
#define Y_SWL_OP 407
#define Y_SWR_OP 408
#define Y_SW_OP 409
#define Y_SYSCALL_OP 410
#define Y_TLBP_OP 411
#define Y_TLBR_OP 412
#define Y_TLBWI_OP 413
#define Y_TLBWR_OP 414
#define Y_XORI_OP 415
#define Y_XOR_OP 416
#define Y_ABS_POP 417
#define Y_BAL_POP 418
#define Y_BEQZ_POP 419
#define Y_BGEU_POP 420
#define Y_BGE_POP 421
#define Y_BGTU_POP 422
#define Y_BGT_POP 423
#define Y_BLEU_POP 424
#define Y_BLE_POP 425
#define Y_BLTU_POP 426
#define Y_BLT_POP 427
#define Y_BNEZ_POP 428
#define Y_B_POP 429
#define Y_LA_POP 430
#define Y_LD_POP 431
#define Y_LI_POP 432
#define Y_LI_D_POP 433
#define Y_LI_S_POP 434
#define Y_L_D_POP 435
#define Y_L_S_POP 436
#define Y_MFC1_D_POP 437
#define Y_MTC1_D_POP 438
#define Y_MOVE_POP 439
#define Y_MULOU_POP 440
#define Y_MULO_POP 441
#define Y_MUL_POP 442
#define Y_NEGU_POP 443
#define Y_NEG_POP 444
#define Y_NOP_POP 445
#define Y_NOT_POP 446
#define Y_REMU_POP 447
#define Y_REM_POP 448
#define Y_ROL_POP 449
#define Y_ROR_POP 450
#define Y_SD_POP 451
#define Y_SEQ_POP 452
#define Y_SGEU_POP 453
#define Y_SGE_POP 454
#define Y_SGTU_POP 455
#define Y_SGT_POP 456
#define Y_SLEU_POP 457
#define Y_SLE_POP 458
#define Y_SNE_POP 459
#define Y_S_D_POP 460
#define Y_S_S_POP 461
#define Y_ULHU_POP 462
#define Y_ULH_POP 463
#define Y_ULW_POP 464
#define Y_USH_POP 465
#define Y_USW_POP 466
#define Y_ALIAS_DIR 467
#define Y_ALIGN_DIR 468
#define Y_ASCII_DIR 469
#define Y_ASCIIZ_DIR 470
#define Y_ASM0_DIR 471
#define Y_BGNB_DIR 472
#define Y_BYTE_DIR 473
#define Y_COMM_DIR 474
#define Y_DATA_DIR 475
#define Y_DOUBLE_DIR 476
#define Y_ENDB_DIR 477
#define Y_ENDR_DIR 478
#define Y_END_DIR 479
#define Y_ENT_DIR 480
#define Y_ERR_DIR 481
#define Y_EXTERN_DIR 482
#define Y_FILE_DIR 483
#define Y_FLOAT_DIR 484
#define Y_FMASK_DIR 485
#define Y_FRAME_DIR 486
#define Y_GLOBAL_DIR 487
#define Y_HALF_DIR 488
#define Y_K_TEXT_DIR 489
#define Y_K_DATA_DIR 490
#define Y_LABEL_DIR 491
#define Y_LCOMM_DIR 492
#define Y_LIVEREG_DIR 493
#define Y_LOC_DIR 494
#define Y_MASK_DIR 495
#define Y_NOALIAS_DIR 496
#define Y_OPTIONS_DIR 497
#define Y_RDATA_DIR 498
#define Y_REPEAT_DIR 499
#define Y_SDATA_DIR 500
#define Y_SET_DIR 501
#define Y_SPACE_DIR 502
#define Y_STRUCT_DIR 503
#define Y_TEXT_DIR 504
#define Y_VERSTAMP_DIR 505
#define Y_VREG_DIR 506
#define Y_WORD_DIR 507
#define YYERRCODE 256
static YYCONST short yylhs[] = {                                        -1,
    2,    0,    1,    1,    3,    3,    8,    4,   10,    4,
    4,    7,    7,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   14,
   14,   14,   16,   20,   20,   21,   21,   21,   22,   22,
   22,   22,   22,   22,   24,   24,   24,   25,   25,   25,
   27,   27,   29,   29,   29,   29,   29,   29,   29,   31,
   31,   31,   32,   32,   32,   32,   33,   33,   33,   35,
   35,   35,   36,   37,   37,   38,   38,   38,   38,   39,
   39,   39,   41,   41,   42,   42,   43,   43,   44,   44,
   40,   40,   45,   45,   45,   45,   45,   45,   45,   45,
   47,   47,   47,   47,   47,   47,   48,   48,   49,   49,
   51,   51,   52,   52,   53,   53,   54,   54,   55,   55,
   55,   55,   57,   57,   58,   58,   59,   59,   61,   61,
   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
   63,   63,   63,   63,   63,   63,   63,   63,   64,   64,
   65,   65,   65,   65,   65,   65,   65,   65,   67,   67,
   67,   67,   67,   67,   68,   68,   69,   69,   69,   69,
   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
   69,   69,   69,   69,   69,   69,   69,   69,    9,    9,
   72,    9,   73,    9,    9,    9,   75,    9,    9,    9,
    9,    9,    9,   77,    9,    9,    9,    9,    9,    9,
    9,    9,    9,   79,    9,    9,    9,    9,   81,    9,
    9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,   82,    9,   84,   13,   83,   83,   83,   83,   83,
   83,   83,   83,   83,   83,   86,   50,   17,   34,   18,
   18,   18,   18,   18,   85,   85,   85,   12,   28,   30,
   56,   60,   23,   80,   19,   26,   66,   87,   15,   15,
   46,   71,   71,   88,   88,   90,   89,   70,   70,   74,
   74,   74,   76,   76,   92,   78,   91,   91,   93,    5,
};
static YYCONST short yylen[] = {                                         2,
    0,    2,    2,    1,    2,    3,    0,    3,    0,    3,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    1,    2,
    1,    3,    3,    3,    3,    3,    4,    4,    3,    4,
    4,    3,    4,    3,    4,    3,    4,    4,    4,    4,
    3,    4,    4,    3,    3,    4,    4,    4,    4,    3,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    2,    3,    3,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    2,    2,    3,    2,    0,
    3,    2,    2,    3,    3,    3,    4,    3,    3,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    3,    2,
    0,    3,    0,    3,    1,    2,    0,    3,    3,    1,
    2,    1,    2,    0,    3,    2,    2,    1,    2,    3,
    3,    1,    3,    0,    3,    3,    4,    2,    0,    3,
    2,    3,    3,    3,    3,    3,    2,    2,    1,    2,
    1,    2,    2,    2,    2,    1,    2,    1,    2,    3,
    4,    0,    3,    0,    2,    3,    1,    4,    1,    4,
    3,    3,    3,    6,    6,    0,    2,    1,    1,    1,
    6,    1,    3,    3,    1,    3,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    1,    1,    3,    0,    2,    1,    1,    2,
    1,    3,    2,    1,    0,    2,    1,    0,    0,    2,
};
static YYCONST short yydefred[] = {                                      1,
    0,    0,   13,   12,  230,  229,  144,  143,  134,  232,
  133,  231,  147,  135,  177,  173,  178,  174,  179,  175,
  180,  176,  189,  182,  181,  183,  184,  186,  185,  190,
    0,  221,  222,  223,  224,  225,  226,  227,  228,  239,
  240,  241,  242,  243,  244,  265,  249,  263,  247,  277,
  261,  275,  259,  276,  260,  272,  256,  274,  258,  278,
  262,  267,  251,  268,  252,  273,  257,  271,  255,  266,
  250,  269,  253,  270,  254,  264,  248,  157,  234,  156,
  233,  202,  201,  200,  199,  102,  101,  104,  103,  113,
  110,  116,  111,  112,  106,  107,  105,  211,  212,  214,
  215,  207,  208,  206,  205,  216,  217,  219,  220,  209,
  210,  172,  171,  236,  235,  246,  245,  153,  148,  137,
  109,  131,  119,  120,  140,  150,  146,  145,  139,  138,
  141,  151,  142,  152,  155,  238,  154,  237,  125,  128,
  126,  127,  122,  123,  121,  132,  149,  136,    0,  204,
  187,  194,  193,  192,  191,  198,  197,  196,  195,  188,
  203,    0,  108,    0,    0,    0,  118,  117,  213,  218,
    0,  162,  161,  160,    0,    0,   31,    0,  159,  158,
    0,    0,  124,  169,  168,  167,  166,  165,  164,  163,
  170,  130,  129,  115,  114,    0,    0,    0,    0,    0,
  281,  283,  285,    0,  287,  389,    0,  294,    0,  298,
  385,  389,  302,  389,    0,  304,    0,    0,  389,  309,
    0,    0,  389,  389,    0,    0,    0,    0,  389,    0,
    0,    0,  389,    0,    0,    0,    0,    0,  332,    2,
    0,    4,    0,    7,   11,    9,    0,    0,    0,    0,
    0,    0,    0,    0,   29,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  389,
    0,    0,    0,    0,    0,    0,    0,    0,  389,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   30,  364,    0,  358,  334,    0,  368,    0,  365,    0,
    0,    0,    0,    0,    0,    0,  334,  334,  363,  334,
    0,  378,  379,  280,    0,    0,  286,  376,    0,  291,
    0,  297,  296,    0,    0,    0,    0,    0,    0,    0,
  308,  376,  329,  293,  311,    0,    0,    0,    0,    0,
  317,  320,  318,  322,  323,  324,  325,  327,    0,    0,
  376,    3,    5,    0,    0,    0,  334,  369,  370,  334,
    0,  334,  334,  334,  334,  334,  366,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  359,    0,    0,
    0,    0,  371,   73,  389,  389,    0,    0,    0,    0,
    0,   87,   86,    0,    0,   89,    0,   92,  362,   93,
    0,    0,    0,    0,    0,    0,    0,  390,   32,   17,
    0,    0,    0,    0,  352,   18,  350,   19,   20,   36,
   34,   33,   35,    0,    0,   21,   27,   26,  279,    0,
    0,  373,    0,    0,    0,    0,  289,  384,    0,  387,
  386,  300,  301,  303,    0,  306,    0,    0,  312,  313,
  314,  315,  316,  330,    0,    0,    6,    8,   10,   14,
   15,   16,  348,   22,   23,   24,   25,   28,   39,    0,
   42,    0,   44,    0,  349,    0,   46,    0,   51,    0,
   54,    0,    0,    0,   60,  360,    0,    0,    0,    0,
   74,   75,  389,  389,    0,  389,  389,  389,  389,  389,
  389,  389,  389,   88,   91,   94,   95,   96,    0,   98,
  367,   99,  100,    0,    0,  335,    0,  357,    0,    0,
    0,    0,   64,   62,   63,   61,    0,  372,  380,    0,
  377,  383,  307,  331,   38,   37,   41,   40,   43,   45,
   47,   48,   50,   49,   53,   52,   57,   56,   59,   58,
   66,   65,   68,   67,   70,   69,   72,   71,   76,   77,
  347,   78,   79,   80,   81,   82,   83,   84,   85,   97,
    0,    0,    0,    0,    0,  389,  356,  353,  354,    0,
  375,  382,    0,    0,    0,  336,    0,  342,    0,  340,
    0,    0,  338,    0,    0,    0,  351,  344,  345,
};
static YYCONST short yydgoto[] = {                                       1,
  240,    2,  241,  242,  415,  244,  245,  355,  246,  356,
  247,  293,  410,  248,  360,  249,  462,  463,  298,  250,
  251,  252,  308,  253,  254,  366,  255,  377,  256,  485,
  257,  258,  259,  477,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  384,  271,  272,  273,  494,
  274,  275,  276,  277,  278,  394,  279,  280,  281,  398,
  282,  283,  284,  285,  286,  510,  287,  288,  289,  314,
  431,  315,  316,  434,  318,  439,  321,  323,  328,  378,
  332,  351,  516,  411,  417,  495,  299,  432,  435,  436,
  441,  324,  290,
};
static YYCONST short yysindex[] = {                                      0,
    0,  275,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -254,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -244,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -244,    0, -244, -237, -237,    0,    0,    0,    0,
 -244,    0,    0,    0, -244, -244,    0, -244,    0,    0,
 -244, -244,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -244, -244, -244, -224, -218,
    0,    0,    0, -212,    0,    0, -207,    0, -203,    0,
    0,    0,    0,    0, -198,    0, -193, -244,    0,    0,
 -185, -167,    0,    0, -154, -147, -137, -134,    0, -127,
 -218, -113,    0, -218, -218,  -72,  -66, -244,    0,    0,
  275,    0,  -13,    0,    0,    0, -244, -251, -244, -244,
 -237, -244, -251, -237,    0, -244, -244, -244, -244, -244,
 -244, -244, -244, -244, -244, -244, -244, -244, -244,    0,
 -244, -244, -244, -244, -244, -244, -244, -244,    0, -251,
 -244, -244, -244, -251, -237, -237, -237, -237, -237,  -86,
    0,    0, -244,    0,    0,  -24,    0,  -83,    0,  -73,
 -244, -244, -244, -244, -244, -244,    0,    0,    0,    0,
  -64,    0,    0,    0,  -60,  -60,    0,    0, -218,    0,
  -55,    0,    0,    0,  -48, -218,  -37,  -55,  -31,  -29,
    0,    0,    0,    0,    0, -218,  -16,   16,   19,  -20,
    0,    0,    0,    0,    0,    0,    0,    0,   20,   21,
    0,    0,    0,   26, -156, -156,    0,    0,    0,    0,
  -24,    0,    0,    0,    0,    0,    0,  -36, -194,  -36,
  -36, -244,  -36,  -36, -244, -244, -244,    0, -244, -244,
 -244, -244,    0,    0,    0,    0, -244, -244, -244, -244,
 -244,    0,    0, -244,    0,    0, -251,    0,    0,    0,
 -251, -251, -237, -237, -237, -237, -237,    0,    0,    0,
  -22,  -41,   48,   35,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -36,  -36,    0,    0,    0,    0,  199,
  -60,    0,  -60,    0,  201, -218,    0,    0,   31,    0,
    0,    0,    0,    0,   31,    0, -244,    0,    0,    0,
    0,    0,    0,    0,   37,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -36,
    0, -151,    0,  -24,    0,  -24,    0, -112,    0,  -36,
    0,  -36,  -36,  -36,    0,    0,  -36,  -36,  -36,  -36,
    0,    0,    0,    0,  -24,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -237,    0,
    0,    0,    0,    6, -244,    0,   60,    0,   38,   35,
   35,  257,    0,    0,    0,    0,   40,    0,    0,   41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -244,   35,   35,  260, -244,    0,    0,    0,    0,  240,
    0,    0,  262,  265,  266,    0,  267,    0,  245,    0,
 -244, -244,    0,   50,  269,  277,    0,    0,    0,
};
static YYCONST short yyrindex[] = {                                      0,
    0,   56,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   56,
    0,    0,    0,    0,    0,    0, -116,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -98,  -94,    0,    0,    0,    0,    0,    0,    0,  -87,
   56,  -85,    0,   56,   56,  -80,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   56,    0,
    0,    0,    0, -176,  -78,   56,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   56,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -10,  -10,  -10,  -10,
  -10,    0,    0,    0, -199,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -18,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -243,
  -74,    0,  -68, -187, -181,   56,    0,    0,  -44,    0,
    0,    0,    0,    0,  -42,    0,    0, -170,    0,    0,
    0,    0,    0,    0,    0, -161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -38,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   -6,    0,    0,   -4,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    9,   12,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static YYCONST short yygindex[] = {                                      0,
    0,    0,    0,   78,   -2,    0,  -84,    0,    0,    0,
    0,  255, -102,    0, -240,    0, -363, -288, -157,    0,
    0,    0, -195,    0,    0, -260,    0,   84,    0,  -76,
    0,    0,    0, -155,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -210,    0,    0,    0, -222,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -9,
    0,    0,    0,    0,    0, -364,    0,    0,    0, -171,
    4,    0,    0, -301,    0,   -5,    0,    0,    0, -143,
    0,    0,    0,    0, -387,    0, -253, -275, -422,    0,
    0,    0,    0,
};
#define YYTABLESIZE 782
static YYCONST short yytable[] = {                                     243,
  367,  519,  310,  414,  291,  294,  473,  416,  300,  358,
  359,  529,  365,  374,  374,  414,  292,  515,  294,  374,
  294,  355,  355,  517,  297,  529,  522,  294,  407,  346,
  448,  294,  294,  529,  294,  367,  311,  294,  294,  397,
  312,  512,  513,  402,  353,  571,  317,  354,  572,  456,
  573,  320,  294,  309,  309,  322,  364,  359,  359,  343,
  327,  361,  346,  347,  471,  329,  292,  393,  396,  288,
  288,  376,  376,  333,  330,  381,  381,  381,  381,  469,
  388,  388,  475,  389,  479,  481,  310,  310,  376,  376,
  520,  334,  521,  363,  350,  333,  333,  376,  376,  575,
    3,    4,  576,  294,  337,  294,  294,  537,  309,  292,
  539,  338,  294,  294,  294,  294,  294,  294,  294,  294,
  294,  339,  294,  294,  294,  294,  340,  403,  404,  405,
  406,  342,  578,  579,  395,  523,  525,  399,  399,  399,
  290,  290,  508,  509,  570,  344,  541,  437,  292,  367,
  367,  511,  511,  511,  443,  528,  505,  528,  328,  328,
  506,  507,  292,  292,  449,  497,  499,  501,  503,  319,
  319,  321,  321,  408,  491,  492,  326,  326,  299,  299,
  418,  535,  282,  282,  584,  585,  348,  475,  284,  284,
  419,  543,  349,  545,  547,  549,  429,  313,  551,  553,
  555,  557,  430,  319,  426,  427,  561,  428,  438,  325,
  442,  326,  295,  295,  305,  305,  331,  518,   55,   55,
  335,  336,  412,  413,  292,  444,  341,  446,  313,  447,
  345,  313,  313,  486,  412,  413,  412,  514,  355,  355,
  453,  355,  450,  486,  486,  486,  486,  486,  346,  346,
  339,  339,  337,  337,  460,  511,  527,  461,  530,  464,
  465,  466,  467,  468,  531,  341,  341,  383,  343,  343,
  458,  459,  400,  401,  451,  383,  383,  452,  454,  455,
  486,  486,  559,  560,  457,  562,  563,  564,  565,  566,
  567,  568,  569,  412,  532,  534,  577,  580,  581,  582,
  586,  589,  590,  533,  591,  592,  594,  593,  597,  598,
  493,  496,  498,  500,  502,  389,  313,  599,  352,  433,
  540,  440,  445,  313,    0,    0,  486,    0,  486,    0,
    0,    0,    0,  313,  486,    0,  486,    0,  486,  486,
  486,    0,    0,  486,  486,  486,  486,  524,  526,    0,
    0,    0,    0,    0,  385,  386,  387,  388,  389,  390,
  391,  392,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  574,    0,    0,    0,    0,  409,    0,    0,    0,
    0,    0,  383,  383,  420,  421,  422,  423,  424,  425,
    0,    0,    0,  536,    0,  538,    0,    0,    0,    0,
    0,  542,    0,  544,    0,  546,  548,  550,    0,    0,
  552,  554,  556,  558,    0,    0,  295,    0,  296,    0,
    0,    0,    0,    0,    0,  301,    0,  583,    0,  302,
  303,  587,  304,  313,    0,  305,  306,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  595,  596,    0,
  307,  470,  472,  474,  476,  478,  480,  482,  483,  484,
    0,    0,  487,  488,  489,  490,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  504,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  383,  383,    0,  383,  383,  383,  383,  383,  383,  383,
  383,  357,    0,  361,  362,    0,    0,    0,    0,    0,
  368,  369,  370,  371,  372,  373,  374,  375,  376,    0,
  379,  380,  381,  382,    0,    0,    0,    0,    0,    0,
    0,    3,    4,    0,    0,    0,    0,    0,    0,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
    0,    0,    0,  588,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
  142,  143,  144,  145,  146,    0,    0,    0,    0,  147,
  148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
  178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,
};
static YYCONST short yycheck[] = {                                       2,
  254,   43,  198,   40,  259,  149,  370,  296,  166,  261,
  262,  434,  253,  257,  258,   40,  261,   40,  162,  263,
  164,   40,   41,  411,  262,  448,  414,  171,  289,   40,
  332,  175,  176,  456,  178,  289,  261,  181,  182,  280,
  259,  406,  407,  284,   58,   40,  259,   61,   43,  351,
   45,  259,  196,  197,  198,  259,  252,  257,  258,  231,
  259,  261,  234,  235,  259,  259,  261,  278,  279,  257,
  258,  259,  260,  259,  218,  257,  258,  259,  260,  368,
  257,  258,  371,  260,  373,  374,  257,  258,  259,  260,
   43,  259,   45,  251,  238,  257,  258,  259,  260,   40,
  257,  258,   43,  247,  259,  249,  250,  259,  252,  261,
  474,  259,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  259,  266,  267,  268,  269,  261,  285,  286,  287,
  288,  259,  520,  521,  278,  424,  425,  281,  282,  283,
  257,  258,  403,  404,  509,  259,  259,  319,  261,  403,
  404,  405,  406,  407,  326,  431,  397,  433,  257,  258,
  401,  402,  257,  258,  336,  388,  389,  390,  391,  257,
  258,  257,  258,  260,  385,  386,  257,  258,  257,  258,
  264,  470,  257,  258,  572,  573,  259,  476,  257,  258,
  264,  480,  259,  482,  483,  484,  261,  200,  487,  488,
  489,  490,  263,  206,  307,  308,  495,  310,  264,  212,
  259,  214,  257,  258,  257,  258,  219,  259,  257,  258,
  223,  224,  259,  260,  261,  263,  229,  259,  231,  259,
  233,  234,  235,  377,  259,  260,  259,  260,  257,  258,
  261,  260,  259,  387,  388,  389,  390,  391,  259,  260,
  257,  258,  257,  258,  357,  509,   58,  360,   58,  362,
  363,  364,  365,  366,  436,  257,  258,  270,  257,  258,
  355,  356,  282,  283,  259,  278,  279,  259,  259,  259,
  424,  425,  493,  494,  259,  496,  497,  498,  499,  500,
  501,  502,  503,  259,  264,  259,  259,   41,  259,  259,
   41,   62,   41,  447,   40,   40,   62,   41,  259,   41,
  387,  388,  389,  390,  391,  260,  319,   41,  241,  316,
  476,  324,  328,  326,   -1,   -1,  470,   -1,  472,   -1,
   -1,   -1,   -1,  336,  478,   -1,  480,   -1,  482,  483,
  484,   -1,   -1,  487,  488,  489,  490,  424,  425,   -1,
   -1,   -1,   -1,   -1,  271,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  515,   -1,   -1,   -1,   -1,  293,   -1,   -1,   -1,
   -1,   -1,  385,  386,  301,  302,  303,  304,  305,  306,
   -1,   -1,   -1,  470,   -1,  472,   -1,   -1,   -1,   -1,
   -1,  478,   -1,  480,   -1,  482,  483,  484,   -1,   -1,
  487,  488,  489,  490,   -1,   -1,  162,   -1,  164,   -1,
   -1,   -1,   -1,   -1,   -1,  171,   -1,  571,   -1,  175,
  176,  575,  178,  436,   -1,  181,  182,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  591,  592,   -1,
  196,  368,  369,  370,  371,  372,  373,  374,  375,  376,
   -1,   -1,  379,  380,  381,  382,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  493,  494,   -1,  496,  497,  498,  499,  500,  501,  502,
  503,  247,   -1,  249,  250,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,  259,  260,  261,  262,  263,  264,   -1,
  266,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,   -1,   -1,   -1,   -1,   -1,   -1,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
   -1,   -1,   -1,  576,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,   -1,   -1,   -1,   -1,  415,
  416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
  426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
  446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
  456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
  466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
  486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
  506,  507,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 507
#if YYDEBUG
static YYCONST char *YYCONST yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,"'+'",0,"'-'",0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,"'='",
"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"Y_EOF","Y_NL","Y_INT","Y_ID","Y_REG","Y_FP_REG","Y_STR","Y_FP","Y_ABS_D_OP",
"Y_ABS_S_OP","Y_ADDIU_OP","Y_ADDI_OP","Y_ADDU_OP","Y_ADD_D_OP","Y_ADD_OP",
"Y_ADD_S_OP","Y_ANDI_OP","Y_AND_OP","Y_BC0F_OP","Y_BC0T_OP","Y_BC1F_OP",
"Y_BC1T_OP","Y_BC2F_OP","Y_BC2T_OP","Y_BC3F_OP","Y_BC3T_OP","Y_BEQ_OP",
"Y_BGEZAL_OP","Y_BGEZ_OP","Y_BGTZ_OP","Y_BLEZ_OP","Y_BLTZAL_OP","Y_BLTZ_OP",
"Y_BNE_OP","Y_BREAK_OP","Y_CFC0_OP","Y_CFC1_OP","Y_CFC2_OP","Y_CFC3_OP",
"Y_COP0_OP","Y_COP1_OP","Y_COP2_OP","Y_COP3_OP","Y_CTC0_OP","Y_CTC1_OP",
"Y_CTC2_OP","Y_CTC3_OP","Y_CVT_D_S_OP","Y_CVT_D_W_OP","Y_CVT_S_D_OP",
"Y_CVT_S_W_OP","Y_CVT_W_D_OP","Y_CVT_W_S_OP","Y_C_EQ_D_OP","Y_C_EQ_S_OP",
"Y_C_F_D_OP","Y_C_F_S_OP","Y_C_LE_D_OP","Y_C_LE_S_OP","Y_C_LT_D_OP",
"Y_C_LT_S_OP","Y_C_NGE_D_OP","Y_C_NGE_S_OP","Y_C_NGLE_D_OP","Y_C_NGLE_S_OP",
"Y_C_NGL_D_OP","Y_C_NGL_S_OP","Y_C_NGT_D_OP","Y_C_NGT_S_OP","Y_C_OLT_D_OP",
"Y_C_OLT_S_OP","Y_C_OLE_D_OP","Y_C_OLE_S_OP","Y_C_SEQ_D_OP","Y_C_SEQ_S_OP",
"Y_C_SF_D_OP","Y_C_SF_S_OP","Y_C_UEQ_D_OP","Y_C_UEQ_S_OP","Y_C_ULT_D_OP",
"Y_C_ULT_S_OP","Y_C_ULE_D_OP","Y_C_ULE_S_OP","Y_C_UN_D_OP","Y_C_UN_S_OP",
"Y_DIVU_OP","Y_DIV_D_OP","Y_DIV_OP","Y_DIV_S_OP","Y_JALR_OP","Y_JAL_OP",
"Y_JR_OP","Y_J_OP","Y_LBU_OP","Y_LB_OP","Y_LHU_OP","Y_LH_OP","Y_LUI_OP",
"Y_LWC0_OP","Y_LWC1_OP","Y_LWC2_OP","Y_LWC3_OP","Y_LWL_OP","Y_LWR_OP","Y_LW_OP",
"Y_MFC0_OP","Y_MFC1_OP","Y_MFC2_OP","Y_MFC3_OP","Y_MFHI_OP","Y_MFLO_OP",
"Y_MOV_D_OP","Y_MOV_S_OP","Y_MTC0_OP","Y_MTC1_OP","Y_MTC2_OP","Y_MTC3_OP",
"Y_MTHI_OP","Y_MTLO_OP","Y_MULTU_OP","Y_MULT_OP","Y_MUL_D_OP","Y_MUL_S_OP",
"Y_NEG_D_OP","Y_NEG_S_OP","Y_NOR_OP","Y_ORI_OP","Y_OR_OP","Y_PFW_OP","Y_RFE_OP",
"Y_SB_OP","Y_SH_OP","Y_SLLV_OP","Y_SLL_OP","Y_SLTIU_OP","Y_SLTI_OP","Y_SLTU_OP",
"Y_SLT_OP","Y_SRAV_OP","Y_SRA_OP","Y_SRLV_OP","Y_SRL_OP","Y_SUBU_OP",
"Y_SUB_D_OP","Y_SUB_OP","Y_SUB_S_OP","Y_SWC0_OP","Y_SWC1_OP","Y_SWC2_OP",
"Y_SWC3_OP","Y_SWL_OP","Y_SWR_OP","Y_SW_OP","Y_SYSCALL_OP","Y_TLBP_OP",
"Y_TLBR_OP","Y_TLBWI_OP","Y_TLBWR_OP","Y_XORI_OP","Y_XOR_OP","Y_ABS_POP",
"Y_BAL_POP","Y_BEQZ_POP","Y_BGEU_POP","Y_BGE_POP","Y_BGTU_POP","Y_BGT_POP",
"Y_BLEU_POP","Y_BLE_POP","Y_BLTU_POP","Y_BLT_POP","Y_BNEZ_POP","Y_B_POP",
"Y_LA_POP","Y_LD_POP","Y_LI_POP","Y_LI_D_POP","Y_LI_S_POP","Y_L_D_POP",
"Y_L_S_POP","Y_MFC1_D_POP","Y_MTC1_D_POP","Y_MOVE_POP","Y_MULOU_POP",
"Y_MULO_POP","Y_MUL_POP","Y_NEGU_POP","Y_NEG_POP","Y_NOP_POP","Y_NOT_POP",
"Y_REMU_POP","Y_REM_POP","Y_ROL_POP","Y_ROR_POP","Y_SD_POP","Y_SEQ_POP",
"Y_SGEU_POP","Y_SGE_POP","Y_SGTU_POP","Y_SGT_POP","Y_SLEU_POP","Y_SLE_POP",
"Y_SNE_POP","Y_S_D_POP","Y_S_S_POP","Y_ULHU_POP","Y_ULH_POP","Y_ULW_POP",
"Y_USH_POP","Y_USW_POP","Y_ALIAS_DIR","Y_ALIGN_DIR","Y_ASCII_DIR",
"Y_ASCIIZ_DIR","Y_ASM0_DIR","Y_BGNB_DIR","Y_BYTE_DIR","Y_COMM_DIR","Y_DATA_DIR",
"Y_DOUBLE_DIR","Y_ENDB_DIR","Y_ENDR_DIR","Y_END_DIR","Y_ENT_DIR","Y_ERR_DIR",
"Y_EXTERN_DIR","Y_FILE_DIR","Y_FLOAT_DIR","Y_FMASK_DIR","Y_FRAME_DIR",
"Y_GLOBAL_DIR","Y_HALF_DIR","Y_K_TEXT_DIR","Y_K_DATA_DIR","Y_LABEL_DIR",
"Y_LCOMM_DIR","Y_LIVEREG_DIR","Y_LOC_DIR","Y_MASK_DIR","Y_NOALIAS_DIR",
"Y_OPTIONS_DIR","Y_RDATA_DIR","Y_REPEAT_DIR","Y_SDATA_DIR","Y_SET_DIR",
"Y_SPACE_DIR","Y_STRUCT_DIR","Y_TEXT_DIR","Y_VERSTAMP_DIR","Y_VREG_DIR",
"Y_WORD_DIR",
};
static YYCONST char *YYCONST yyrule[] = {
"$accept : LINE",
"$$1 :",
"LINE : $$1 LBL_CMD",
"LBL_CMD : OPT_LBL CMD",
"LBL_CMD : CMD",
"OPT_LBL : ID ':'",
"OPT_LBL : ID '=' Y_INT",
"$$2 :",
"CMD : ASM_CODE $$2 TERM",
"$$3 :",
"CMD : ASM_DIRECTIVE $$3 TERM",
"CMD : TERM",
"TERM : Y_NL",
"TERM : Y_EOF",
"ASM_CODE : LOAD_OP DEST_REG ADDRESS",
"ASM_CODE : LOAD_COP COP_REG ADDRESS",
"ASM_CODE : LOAD_IMM_OP DEST_REG IMM16",
"ASM_CODE : Y_LA_POP DEST_REG ADDRESS",
"ASM_CODE : Y_LI_POP DEST_REG IMM32",
"ASM_CODE : Y_LI_D_POP F_DEST Y_FP",
"ASM_CODE : Y_LI_S_POP F_DEST Y_FP",
"ASM_CODE : Y_ULW_POP DEST_REG ADDRESS",
"ASM_CODE : ULOADH_POP DEST_REG ADDRESS",
"ASM_CODE : LOADF_OP F_DEST ADDRESS",
"ASM_CODE : STORE_OP SOURCE ADDRESS",
"ASM_CODE : STORE_COP COP_REG ADDRESS",
"ASM_CODE : Y_USW_POP SOURCE ADDRESS",
"ASM_CODE : Y_USH_POP SOURCE ADDRESS",
"ASM_CODE : STOREF_OP F_SRC1 ADDRESS",
"ASM_CODE : SYS_OP",
"ASM_CODE : Y_BREAK_OP Y_INT",
"ASM_CODE : Y_NOP_POP",
"ASM_CODE : Y_ABS_POP DEST_REG SRC1",
"ASM_CODE : Y_NEG_POP DEST_REG SRC1",
"ASM_CODE : Y_NEGU_POP DEST_REG SRC1",
"ASM_CODE : Y_NOT_POP DEST_REG SRC1",
"ASM_CODE : Y_MOVE_POP DEST_REG SRC1",
"ASM_CODE : BINARY_OP_I DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OP_I DEST_REG SRC1 IMM32",
"ASM_CODE : BINARY_OP_I DEST_REG IMM32",
"ASM_CODE : BINARY_OPR_I DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OPR_I DEST_REG SRC1 Y_INT",
"ASM_CODE : BINARY_OPR_I DEST_REG Y_INT",
"ASM_CODE : BINARY_IMM_ARITH_OP DEST_REG SRC1 IMM16",
"ASM_CODE : BINARY_IMM_ARITH_OP DEST_REG IMM16",
"ASM_CODE : BINARY_IMM_LOGICAL_OP DEST_REG SRC1 UIMM16",
"ASM_CODE : BINARY_IMM_LOGICAL_OP DEST_REG UIMM16",
"ASM_CODE : SHIFT_OP DEST_REG SRC1 Y_INT",
"ASM_CODE : SHIFT_OP DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OP_NOI DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OP_NOI DEST_REG SRC1 IMM32",
"ASM_CODE : BINARY_OP_NOI DEST_REG IMM32",
"ASM_CODE : SUB_OP DEST_REG SRC1 SRC2",
"ASM_CODE : SUB_OP DEST_REG SRC1 IMM32",
"ASM_CODE : SUB_OP DEST_REG IMM32",
"ASM_CODE : DIV_POP DEST_REG SRC1",
"ASM_CODE : DIV_POP DEST_REG SRC1 SRC2",
"ASM_CODE : DIV_POP DEST_REG SRC1 IMM32",
"ASM_CODE : MUL_POP DEST_REG SRC1 SRC2",
"ASM_CODE : MUL_POP DEST_REG SRC1 IMM32",
"ASM_CODE : MULT_OP SRC1 SRC2",
"ASM_CODE : Y_ROR_POP DEST_REG SRC1 SRC2",
"ASM_CODE : Y_ROL_POP DEST_REG SRC1 SRC2",
"ASM_CODE : Y_ROR_POP DEST_REG SRC1 IMM32",
"ASM_CODE : Y_ROL_POP DEST_REG SRC1 IMM32",
"ASM_CODE : SET_LE_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_LE_POP DEST_REG SRC1 IMM32",
"ASM_CODE : SET_GT_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_GT_POP DEST_REG SRC1 IMM32",
"ASM_CODE : SET_GE_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_GE_POP DEST_REG SRC1 IMM32",
"ASM_CODE : SET_EQ_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_EQ_POP DEST_REG SRC1 IMM32",
"ASM_CODE : NULLARY_BR_OP LABEL",
"ASM_CODE : UNARY_BR_OP SRC1 LABEL",
"ASM_CODE : UNARY_BR_POP SRC1 LABEL",
"ASM_CODE : BINARY_BR_OP SRC1 SRC2 LABEL",
"ASM_CODE : BINARY_BR_OP SRC1 BR_IMM32 LABEL",
"ASM_CODE : BR_GT_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_GT_POP SRC1 BR_IMM32 LABEL",
"ASM_CODE : BR_GE_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_GE_POP SRC1 BR_IMM32 LABEL",
"ASM_CODE : BR_LT_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_LT_POP SRC1 BR_IMM32 LABEL",
"ASM_CODE : BR_LE_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_LE_POP SRC1 BR_IMM32 LABEL",
"ASM_CODE : J_OPS LABEL",
"ASM_CODE : J_OPS SRC1",
"ASM_CODE : J_OPS DEST SRC1",
"ASM_CODE : B_OP LABEL",
"ASM_CODE :",
"ASM_CODE : MOVE_COP_OP COP_REG COP_REG",
"ASM_CODE : MOV_FROM_HILO_OP REG",
"ASM_CODE : MOV_TO_HILO_OP REG",
"ASM_CODE : MOV_COP_OP REG COP_REG",
"ASM_CODE : CTL_COP_OP COP_REG COP_REG",
"ASM_CODE : FP_ABS_OP F_DEST F_SRC1",
"ASM_CODE : FP_BINARY_OP F_DEST F_SRC1 F_SRC2",
"ASM_CODE : FP_CONVERT_OP F_DEST F_SRC2",
"ASM_CODE : FP_NEG_OP F_DEST F_SRC2",
"ASM_CODE : FP_CMP_OP F_SRC1 F_SRC2",
"LOAD_OP : Y_LB_OP",
"LOAD_OP : Y_LBU_OP",
"LOAD_OP : Y_LH_OP",
"LOAD_OP : Y_LHU_OP",
"LOAD_OP : Y_LW_OP",
"LOAD_OP : Y_LWL_OP",
"LOAD_OP : Y_LWR_OP",
"LOAD_OP : Y_LD_POP",
"LOAD_OP : Y_PFW_OP",
"LOAD_COP : Y_LWC0_OP",
"LOAD_COP : Y_LWC2_OP",
"LOAD_COP : Y_LWC3_OP",
"LOAD_IMM_OP : Y_LUI_OP",
"ULOADH_POP : Y_ULH_POP",
"ULOADH_POP : Y_ULHU_POP",
"LOADF_OP : Y_LWC1_OP",
"LOADF_OP : Y_L_S_POP",
"LOADF_OP : Y_L_D_POP",
"STORE_OP : Y_SB_OP",
"STORE_OP : Y_SH_OP",
"STORE_OP : Y_SW_OP",
"STORE_OP : Y_SWL_OP",
"STORE_OP : Y_SWR_OP",
"STORE_OP : Y_SD_POP",
"STORE_COP : Y_SWC0_OP",
"STORE_COP : Y_SWC2_OP",
"STORE_COP : Y_SWC3_OP",
"STOREF_OP : Y_SWC1_OP",
"STOREF_OP : Y_S_S_POP",
"STOREF_OP : Y_S_D_POP",
"SYS_OP : Y_RFE_OP",
"SYS_OP : Y_SYSCALL_OP",
"BINARY_OP_I : Y_ADD_OP",
"BINARY_OP_I : Y_ADDU_OP",
"BINARY_OP_I : Y_AND_OP",
"BINARY_OP_I : Y_XOR_OP",
"BINARY_OP_I : Y_OR_OP",
"BINARY_OP_I : Y_SLT_OP",
"BINARY_OP_I : Y_SLTU_OP",
"BINARY_OPR_I : Y_SLLV_OP",
"BINARY_OPR_I : Y_SRAV_OP",
"BINARY_OPR_I : Y_SRLV_OP",
"BINARY_IMM_ARITH_OP : Y_ADDI_OP",
"BINARY_IMM_ARITH_OP : Y_ADDIU_OP",
"BINARY_IMM_ARITH_OP : Y_SLTI_OP",
"BINARY_IMM_ARITH_OP : Y_SLTIU_OP",
"BINARY_IMM_LOGICAL_OP : Y_ANDI_OP",
"BINARY_IMM_LOGICAL_OP : Y_ORI_OP",
"BINARY_IMM_LOGICAL_OP : Y_XORI_OP",
"SHIFT_OP : Y_SLL_OP",
"SHIFT_OP : Y_SRA_OP",
"SHIFT_OP : Y_SRL_OP",
"BINARY_OP_NOI : Y_NOR_OP",
"SUB_OP : Y_SUB_OP",
"SUB_OP : Y_SUBU_OP",
"DIV_POP : Y_DIV_OP",
"DIV_POP : Y_DIVU_OP",
"DIV_POP : Y_REM_POP",
"DIV_POP : Y_REMU_POP",
"MUL_POP : Y_MUL_POP",
"MUL_POP : Y_MULO_POP",
"MUL_POP : Y_MULOU_POP",
"SET_LE_POP : Y_SLE_POP",
"SET_LE_POP : Y_SLEU_POP",
"SET_GT_POP : Y_SGT_POP",
"SET_GT_POP : Y_SGTU_POP",
"SET_GE_POP : Y_SGE_POP",
"SET_GE_POP : Y_SGEU_POP",
"SET_EQ_POP : Y_SEQ_POP",
"SET_EQ_POP : Y_SNE_POP",
"MULT_OP : Y_MULT_OP",
"MULT_OP : Y_MULTU_OP",
"NULLARY_BR_OP : Y_BC0T_OP",
"NULLARY_BR_OP : Y_BC1T_OP",
"NULLARY_BR_OP : Y_BC2T_OP",
"NULLARY_BR_OP : Y_BC3T_OP",
"NULLARY_BR_OP : Y_BC0F_OP",
"NULLARY_BR_OP : Y_BC1F_OP",
"NULLARY_BR_OP : Y_BC2F_OP",
"NULLARY_BR_OP : Y_BC3F_OP",
"UNARY_BR_OP : Y_BGEZ_OP",
"UNARY_BR_OP : Y_BGEZAL_OP",
"UNARY_BR_OP : Y_BGTZ_OP",
"UNARY_BR_OP : Y_BLEZ_OP",
"UNARY_BR_OP : Y_BLTZ_OP",
"UNARY_BR_OP : Y_BLTZAL_OP",
"UNARY_BR_POP : Y_BEQZ_POP",
"UNARY_BR_POP : Y_BNEZ_POP",
"BINARY_BR_OP : Y_BEQ_OP",
"BINARY_BR_OP : Y_BNE_OP",
"BR_GT_POP : Y_BGT_POP",
"BR_GT_POP : Y_BGTU_POP",
"BR_GE_POP : Y_BGE_POP",
"BR_GE_POP : Y_BGEU_POP",
"BR_LT_POP : Y_BLT_POP",
"BR_LT_POP : Y_BLTU_POP",
"BR_LE_POP : Y_BLE_POP",
"BR_LE_POP : Y_BLEU_POP",
"J_OPS : Y_J_OP",
"J_OPS : Y_JR_OP",
"J_OPS : Y_JAL_OP",
"J_OPS : Y_JALR_OP",
"B_OP : Y_B_POP",
"B_OP : Y_BAL_POP",
"MOVE_COP_OP : Y_MOV_S_OP",
"MOVE_COP_OP : Y_MOV_D_OP",
"MOV_FROM_HILO_OP : Y_MFHI_OP",
"MOV_FROM_HILO_OP : Y_MFLO_OP",
"MOV_TO_HILO_OP : Y_MTHI_OP",
"MOV_TO_HILO_OP : Y_MTLO_OP",
"MOV_COP_OP : Y_MFC0_OP",
"MOV_COP_OP : Y_MFC1_OP",
"MOV_COP_OP : Y_MFC1_D_POP",
"MOV_COP_OP : Y_MFC2_OP",
"MOV_COP_OP : Y_MFC3_OP",
"MOV_COP_OP : Y_MTC0_OP",
"MOV_COP_OP : Y_MTC1_OP",
"MOV_COP_OP : Y_MTC1_D_POP",
"MOV_COP_OP : Y_MTC2_OP",
"MOV_COP_OP : Y_MTC3_OP",
"CTL_COP_OP : Y_CFC0_OP",
"CTL_COP_OP : Y_CFC1_OP",
"CTL_COP_OP : Y_CFC2_OP",
"CTL_COP_OP : Y_CFC3_OP",
"CTL_COP_OP : Y_CTC0_OP",
"CTL_COP_OP : Y_CTC1_OP",
"CTL_COP_OP : Y_CTC2_OP",
"CTL_COP_OP : Y_CTC3_OP",
"FP_ABS_OP : Y_ABS_S_OP",
"FP_ABS_OP : Y_ABS_D_OP",
"FP_BINARY_OP : Y_ADD_S_OP",
"FP_BINARY_OP : Y_ADD_D_OP",
"FP_BINARY_OP : Y_DIV_S_OP",
"FP_BINARY_OP : Y_DIV_D_OP",
"FP_BINARY_OP : Y_MUL_S_OP",
"FP_BINARY_OP : Y_MUL_D_OP",
"FP_BINARY_OP : Y_SUB_S_OP",
"FP_BINARY_OP : Y_SUB_D_OP",
"FP_CONVERT_OP : Y_CVT_D_S_OP",
"FP_CONVERT_OP : Y_CVT_D_W_OP",
"FP_CONVERT_OP : Y_CVT_S_D_OP",
"FP_CONVERT_OP : Y_CVT_S_W_OP",
"FP_CONVERT_OP : Y_CVT_W_D_OP",
"FP_CONVERT_OP : Y_CVT_W_S_OP",
"FP_NEG_OP : Y_NEG_S_OP",
"FP_NEG_OP : Y_NEG_D_OP",
"FP_CMP_OP : Y_C_F_S_OP",
"FP_CMP_OP : Y_C_UN_S_OP",
"FP_CMP_OP : Y_C_EQ_S_OP",
"FP_CMP_OP : Y_C_UEQ_S_OP",
"FP_CMP_OP : Y_C_OLT_S_OP",
"FP_CMP_OP : Y_C_OLE_S_OP",
"FP_CMP_OP : Y_C_ULT_S_OP",
"FP_CMP_OP : Y_C_ULE_S_OP",
"FP_CMP_OP : Y_C_SF_S_OP",
"FP_CMP_OP : Y_C_NGLE_S_OP",
"FP_CMP_OP : Y_C_SEQ_S_OP",
"FP_CMP_OP : Y_C_NGL_S_OP",
"FP_CMP_OP : Y_C_LT_S_OP",
"FP_CMP_OP : Y_C_NGE_S_OP",
"FP_CMP_OP : Y_C_LE_S_OP",
"FP_CMP_OP : Y_C_NGT_S_OP",
"FP_CMP_OP : Y_C_F_D_OP",
"FP_CMP_OP : Y_C_UN_D_OP",
"FP_CMP_OP : Y_C_EQ_D_OP",
"FP_CMP_OP : Y_C_UEQ_D_OP",
"FP_CMP_OP : Y_C_OLT_D_OP",
"FP_CMP_OP : Y_C_OLE_D_OP",
"FP_CMP_OP : Y_C_ULT_D_OP",
"FP_CMP_OP : Y_C_ULE_D_OP",
"FP_CMP_OP : Y_C_SF_D_OP",
"FP_CMP_OP : Y_C_NGLE_D_OP",
"FP_CMP_OP : Y_C_SEQ_D_OP",
"FP_CMP_OP : Y_C_NGL_D_OP",
"FP_CMP_OP : Y_C_LT_D_OP",
"FP_CMP_OP : Y_C_NGE_D_OP",
"FP_CMP_OP : Y_C_LE_D_OP",
"FP_CMP_OP : Y_C_NGT_D_OP",
"ASM_DIRECTIVE : Y_ALIAS_DIR Y_REG Y_REG",
"ASM_DIRECTIVE : Y_ALIGN_DIR EXPR",
"$$4 :",
"ASM_DIRECTIVE : Y_ASCII_DIR $$4 STR_LST",
"$$5 :",
"ASM_DIRECTIVE : Y_ASCIIZ_DIR $$5 STR_LST",
"ASM_DIRECTIVE : Y_ASM0_DIR",
"ASM_DIRECTIVE : Y_BGNB_DIR Y_INT",
"$$6 :",
"ASM_DIRECTIVE : Y_BYTE_DIR $$6 EXPR_LST",
"ASM_DIRECTIVE : Y_COMM_DIR ID EXPR",
"ASM_DIRECTIVE : Y_DATA_DIR",
"ASM_DIRECTIVE : Y_DATA_DIR Y_INT",
"ASM_DIRECTIVE : Y_K_DATA_DIR",
"ASM_DIRECTIVE : Y_K_DATA_DIR Y_INT",
"$$7 :",
"ASM_DIRECTIVE : Y_DOUBLE_DIR $$7 FP_EXPR_LST",
"ASM_DIRECTIVE : Y_END_DIR OPTIONAL_ID",
"ASM_DIRECTIVE : Y_ENDB_DIR Y_INT",
"ASM_DIRECTIVE : Y_ENDR_DIR",
"ASM_DIRECTIVE : Y_ENT_DIR ID",
"ASM_DIRECTIVE : Y_ENT_DIR ID Y_INT",
"ASM_DIRECTIVE : Y_EXTERN_DIR ID EXPR",
"ASM_DIRECTIVE : Y_ERR_DIR",
"ASM_DIRECTIVE : Y_FILE_DIR Y_INT Y_STR",
"$$8 :",
"ASM_DIRECTIVE : Y_FLOAT_DIR $$8 FP_EXPR_LST",
"ASM_DIRECTIVE : Y_FMASK_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_FRAME_DIR REGISTER Y_INT REGISTER",
"ASM_DIRECTIVE : Y_GLOBAL_DIR ID",
"$$9 :",
"ASM_DIRECTIVE : Y_HALF_DIR $$9 EXPR_LST",
"ASM_DIRECTIVE : Y_LABEL_DIR ID",
"ASM_DIRECTIVE : Y_LCOMM_DIR ID EXPR",
"ASM_DIRECTIVE : Y_LIVEREG_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_LOC_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_MASK_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_NOALIAS_DIR Y_REG Y_REG",
"ASM_DIRECTIVE : Y_OPTIONS_DIR ID",
"ASM_DIRECTIVE : Y_REPEAT_DIR EXPR",
"ASM_DIRECTIVE : Y_RDATA_DIR",
"ASM_DIRECTIVE : Y_RDATA_DIR Y_INT",
"ASM_DIRECTIVE : Y_SDATA_DIR",
"ASM_DIRECTIVE : Y_SDATA_DIR Y_INT",
"ASM_DIRECTIVE : Y_SET_DIR ID",
"ASM_DIRECTIVE : Y_SPACE_DIR EXPR",
"ASM_DIRECTIVE : Y_STRUCT_DIR EXPR",
"ASM_DIRECTIVE : Y_TEXT_DIR",
"ASM_DIRECTIVE : Y_TEXT_DIR Y_INT",
"ASM_DIRECTIVE : Y_K_TEXT_DIR",
"ASM_DIRECTIVE : Y_K_TEXT_DIR Y_INT",
"ASM_DIRECTIVE : Y_VERSTAMP_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_VREG_DIR REGISTER Y_INT Y_INT",
"$$10 :",
"ASM_DIRECTIVE : Y_WORD_DIR $$10 EXPR_LST",
"$$11 :",
"ADDRESS : $$11 ADDR",
"ADDR : '(' REGISTER ')'",
"ADDR : ABS_ADDR",
"ADDR : ABS_ADDR '(' REGISTER ')'",
"ADDR : Y_ID",
"ADDR : Y_ID '(' REGISTER ')'",
"ADDR : Y_ID '+' ABS_ADDR",
"ADDR : ABS_ADDR '+' ID",
"ADDR : Y_ID '-' ABS_ADDR",
"ADDR : Y_ID '+' ABS_ADDR '(' REGISTER ')'",
"ADDR : Y_ID '-' ABS_ADDR '(' REGISTER ')'",
"$$12 :",
"BR_IMM32 : $$12 IMM32",
"IMM16 : IMM32",
"UIMM16 : IMM32",
"IMM32 : ABS_ADDR",
"IMM32 : '(' ABS_ADDR ')' '>' '>' Y_INT",
"IMM32 : ID",
"IMM32 : Y_ID '+' ABS_ADDR",
"IMM32 : Y_ID '-' ABS_ADDR",
"ABS_ADDR : Y_INT",
"ABS_ADDR : Y_INT '+' Y_INT",
"ABS_ADDR : Y_INT Y_INT",
"DEST_REG : REGISTER",
"SRC1 : REGISTER",
"SRC2 : REGISTER",
"DEST : REGISTER",
"REG : REGISTER",
"SOURCE : REGISTER",
"REGISTER : Y_REG",
"F_DEST : FP_REGISTER",
"F_SRC1 : FP_REGISTER",
"F_SRC2 : FP_REGISTER",
"FP_REGISTER : Y_FP_REG",
"COP_REG : Y_REG",
"COP_REG : Y_FP_REG",
"LABEL : ID",
"STR_LST : STR_LST STR",
"STR_LST : STR",
"STR : Y_STR",
"STR : Y_STR ':' Y_INT",
"$$13 :",
"EXPRESSION : $$13 EXPR",
"EXPR : Y_INT",
"EXPR : ID",
"EXPR_LST : EXPR_LST EXPRESSION",
"EXPR_LST : EXPRESSION",
"EXPR_LST : EXPRESSION ':' Y_INT",
"FP_EXPR_LST : FP_EXPR_LST Y_FP",
"FP_EXPR_LST : Y_FP",
"$$14 :",
"OPTIONAL_ID : $$14 OPT_ID",
"OPT_ID : ID",
"OPT_ID :",
"$$15 :",
"ID : $$15 Y_ID",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
#ifndef YYMAXSTACKSIZE
#define YYMAXSTACKSIZE 10000
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
YYSTYPE yyval;
YYSTYPE yylval;
static short *yyss;
static YYSTYPE *yyvs;
static int yystacksize;
#define yyfree(x) free(x)
extern int yylex();

static YYPTR
YYDEFUN (yymalloc, (bytes), unsigned bytes)
{
    YYPTR ptr = (YYPTR) malloc (bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static YYPTR
YYDEFUN (yyrealloc, (old, bytes), YYPTR old YYAND unsigned bytes)
{
    YYPTR ptr = (YYPTR) realloc (old, bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static int
#ifdef __GNUC__
__inline__
#endif
yygrow ()
{
    int old_stacksize = yystacksize;
    short *new_yyss;
    YYSTYPE *new_yyvs;

    if (yystacksize == YYMAXSTACKSIZE)
        return (1);
    yystacksize += (yystacksize + 1 ) / 2;
    if (yystacksize > YYMAXSTACKSIZE)
        yystacksize = YYMAXSTACKSIZE;
#if YYDEBUG
    if (yydebug)
        printf("yydebug: growing stack size from %d to %d\n",
               old_stacksize, yystacksize);
#endif
    new_yyss = (short *) yyrealloc ((char *)yyss, yystacksize * sizeof (short));
    if (new_yyss == 0)
        return (1);
    new_yyvs = (YYSTYPE *) yyrealloc ((char *)yyvs, yystacksize * sizeof (YYSTYPE));
    if (new_yyvs == 0)
    {
        yyfree (new_yyss);
        return (1);
    }
    yyss = new_yyss;
    yyvs = new_yyvs;
    return (0);
}
#line 2089 "parser.y"

/* Maintain and update the address of labels for the current line. */

#ifdef __STDC__
void
fix_current_label_address (mem_addr new_addr)
#else
void
fix_current_label_address (new_addr)
     mem_addr new_addr;
#endif
{
  label_list *l;

  for (l = this_line_labels; l != NULL; l = l->tail)
    {
      l->head->addr = new_addr;
    }
  clear_labels ();
}


#ifdef __STDC__
static label_list *
cons_label (label *head, label_list *tail)
#else
static label_list *
cons_label (head, tail)
     label *head;
     label_list *tail;
#endif
{
  label_list *c = (label_list *) malloc (sizeof (label_list));

  c->head = head;
  c->tail = tail;
  return (c);
}


#ifdef __STDC__
static void
clear_labels (void)
#else
static void
clear_labels ()
#endif
{
  label_list *n;

  for ( ; this_line_labels != NULL; this_line_labels = n)
    {
      resolve_label_uses(this_line_labels->head);
      n = this_line_labels->tail;
      free (this_line_labels);
    }
}


/* Operations on op codes. */

#ifdef __STDC__
int
op_to_imm_op (int opcode)
#else
int
op_to_imm_op (opcode)
     int opcode;
#endif
{
  switch (opcode)
    {
    case Y_ADD_OP: return (Y_ADDI_OP);
    case Y_ADDU_OP: return (Y_ADDIU_OP);
    case Y_AND_OP: return (Y_ANDI_OP);
    case Y_OR_OP: return (Y_ORI_OP);
    case Y_XOR_OP: return (Y_XORI_OP);
    case Y_SLT_OP: return (Y_SLTI_OP);
    case Y_SLTU_OP: return (Y_SLTIU_OP);
    case Y_SLLV_OP: return (Y_SLL_OP);
    case Y_SRAV_OP: return (Y_SRA_OP);
    case Y_SRLV_OP: return (Y_SRL_OP);
    default: fatal_error ("Can't convert op to immediate op\n"); return (0);
    }
}


#ifdef __STDC__
int
imm_op_to_op (int opcode)
#else
int
imm_op_to_op (opcode)
     int opcode;
#endif
{
  switch (opcode)
    {
    case Y_ADDI_OP: return (Y_ADD_OP);
    case Y_ADDIU_OP: return (Y_ADDU_OP);
    case Y_ANDI_OP: return (Y_AND_OP);
    case Y_ORI_OP: return (Y_OR_OP);
    case Y_XORI_OP: return (Y_XOR_OP);
    case Y_SLTI_OP: return (Y_SLT_OP);
    case Y_SLTIU_OP: return (Y_SLTU_OP);
    case Y_J_OP: return (Y_JR_OP);
    case Y_LUI_OP: return (Y_ADDU_OP);
    case Y_SLL_OP: return (Y_SLLV_OP);
    case Y_SRA_OP: return (Y_SRAV_OP);
    case Y_SRL_OP: return (Y_SRLV_OP);
    default: fatal_error ("Can't convert immediate op to op\n"); return (0);
    }
}


#ifdef __STDC__
static void
nop_inst (void)
#else
static void
nop_inst ()
#endif
{
  r_type_inst (Y_SLL_OP, 0, 0, 0); /* = 0 */
}


#ifdef __STDC__
static void
trap_inst (void)
#else
static void
trap_inst ()
#endif
{
  r_type_inst (Y_BREAK_OP, 0, 0, 0);
}


#ifdef __STDC__
static imm_expr *
branch_offset (int n_inst)
#else
static imm_expr *
branch_offset (n_inst)
     int n_inst;
#endif
{
  return (const_imm_expr (n_inst << 2)); /* Later shifted right 2 places */
}


#ifdef __STDC__
static void
div_inst (int op, int rd, int rs, int rt, int const_divisor)
#else
static void
div_inst (op, rd, rs, rt, const_divisor)
     int op, rd, rs, rt, const_divisor;
#endif
{
  if (rd != 0 && !const_divisor)
    {
      i_type_inst_free (Y_BNE_OP, 0, rt, branch_offset (2));
      trap_inst ();
    }
  if (op == Y_DIV_OP || op == Y_REM_POP)
    r_type_inst (Y_DIV_OP, 0, rs, rt);
  else
    r_type_inst (Y_DIVU_OP, 0, rs, rt);
  if (rd != 0)
    {
      if (op == Y_DIV_OP || op == Y_DIVU_OP)
	r_type_inst (Y_MFLO_OP, rd, 0, 0);
      else
	r_type_inst (Y_MFHI_OP, rd, 0, 0);
    }
}


#ifdef __STDC__
static void
mult_inst (int op, int rd, int rs, int rt)
#else
static void
mult_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
#endif
{
  if (op == Y_MULOU_POP)
    r_type_inst (Y_MULTU_OP, 0, rs, rt);
  else
    r_type_inst (Y_MULT_OP, 0, rs, rt);
  if (op == Y_MULOU_POP && rd != 0)
    {
      r_type_inst (Y_MFHI_OP, 1, 0, 0);	/* Use $at */
      i_type_inst_free (Y_BEQ_OP, 0, 1, branch_offset (2));
      trap_inst ();
    }
  else if (op == Y_MULO_POP && rd != 0)
    {
      r_type_inst (Y_MFHI_OP, 1, 0, 0); /* use $at */
      r_type_inst (Y_MFLO_OP, rd, 0, 0);
      r_sh_type_inst (Y_SRA_OP, rd, rd, 31);
      i_type_inst_free (Y_BEQ_OP, rd, 1, branch_offset (2));
      trap_inst ();
    }
  if (rd != 0)
    r_type_inst (Y_MFLO_OP, rd, 0, 0);
}


#ifdef __STDC__
static void
set_le_inst (int op, int rd, int rs, int rt)
#else
static void
set_le_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
#endif
{
  i_type_inst_free (Y_BNE_OP, rs, rt, branch_offset (3));
  i_type_inst_free (Y_ORI_OP, rd, 0, const_imm_expr (1));
  i_type_inst_free (Y_BEQ_OP, 0, 0, branch_offset (2));
  r_type_inst ((op == Y_SLE_POP ? Y_SLT_OP : Y_SLTU_OP), rd, rs, rt);
}


#ifdef __STDC__
static void
set_gt_inst (int op, int rd, int rs, int rt)
#else
static void
set_gt_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
#endif
{
  r_type_inst (op == Y_SGT_POP ? Y_SLT_OP : Y_SLTU_OP, rd, rt, rs);
}


#ifdef __STDC__
static void
set_ge_inst (int op, int rd, int rs, int rt)
#else
static void
set_ge_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
#endif
{
  i_type_inst_free (Y_BNE_OP, rs, rt, branch_offset (3));
  i_type_inst_free (Y_ORI_OP, rd, 0, const_imm_expr (1));
  i_type_inst_free (Y_BEQ_OP, 0, 0, branch_offset (2));
  r_type_inst (op == Y_SGE_POP ? Y_SLT_OP : Y_SLTU_OP, rd, rt, rs);
}


#ifdef __STDC__
static void
set_eq_inst (int op, int rd, int rs, int rt)
#else
static void
set_eq_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
#endif
{
  imm_expr *if_eq, *if_neq;

  if (op == Y_SEQ_POP)
    if_eq = const_imm_expr (1), if_neq = const_imm_expr (0);
  else
    if_eq = const_imm_expr (0), if_neq = const_imm_expr (1);

  i_type_inst_free (Y_BEQ_OP, rs, rt, branch_offset (3));
  /* RD <- 0 (if not equal) */
  i_type_inst_free (Y_ORI_OP, rd, 0, if_neq);
  i_type_inst_free (Y_BEQ_OP, 0, 0, branch_offset (2)); /* Branch always */
  /* RD <- 1 */
  i_type_inst_free (Y_ORI_OP, rd, 0, if_eq);
}


/* Store the value either as a datum or instruction. */

#ifdef __STDC__
static void
store_word_data (int value)
#else
static void
store_word_data (value)
     int value;
#endif
{
  if (data_dir)
    store_word (value);
  else if (text_dir)
    store_instruction (inst_decode (value));
}



#ifdef __STDC__
void
initialize_parser (char *file_name)
#else
void
initialize_parser (file_name)
     char *file_name;
#endif
{
  input_file_name = file_name;
  only_id = 0;
  data_dir = 0;
  text_dir = 1;
}


#ifdef __STDC__
static void
check_imm_range(imm_expr* expr, int32 min, int32 max)
#else
static void
check_imm_range()
     imm_expr* expr;
     int32 min;
     int32 max;
#endif
{
  if (expr->symbol == NULL || SYMBOL_IS_DEFINED (expr->symbol))
    {
      /* If expression can be evaluated, compare its value against the limits
	 and complain if the value is out of bounds. */
      int32 value = eval_imm_expr (expr);

      if (value < min || max < value)
	{
	  char str[200];
	  sprintf (str, "immediate value (%d) out of range (%d .. %d)",
		   value, min, max);
	  yywarn (str);
	}
    }
}


#ifdef __STDC__
static void
check_uimm_range(imm_expr* expr, uint32 min, uint32 max)
#else
static void
check_uimm_range()
     imm_expr* expr;
     int32 umin;
     int32 umax;
#endif
{
  if (expr->symbol == NULL || SYMBOL_IS_DEFINED (expr->symbol))
    {
      /* If expression can be evaluated, compare its value against the limits
	     and complain if the value is out of bounds. */
      uint32 value = eval_imm_expr (expr);

      if (value < min || max < value)
	{
	  char str[200];
	  sprintf (str, "immediate value (%d) out of range (%d .. %d)",
		   value, min, max);
	  yywarn (str);
	}
    }
}

#ifdef __STDC__
void
yyerror (char *s)
#else
void
yyerror (s)
     char *s;
#endif
{
  parse_error_occurred = 1;
  yywarn (s);
}


#ifdef __STDC__
void
yywarn (char *s)
#else
void
yywarn (s)
     char *s;
#endif
{
  error ("spim: (parser) %s on line %d of file %s\n", s, line_no, input_file_name);
  print_erroneous_line ();
}
#line 1758 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#if YYDEBUG
#ifdef __cplusplus
extern "C" char *getenv();
#else
extern char *getenv();
#endif
#endif

int
yyparse()
{
    register int yym, yyn, yystate;
    register YYSTYPE *yyvsp;
    register short *yyssp;
    short *yysse;
#if YYDEBUG
    register YYCONST char *yys;

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == 0)
    {
        yyss = (short *) yymalloc (YYSTACKSIZE * sizeof (short));
        if (yyss == 0)
          goto yyabort;
        yyvs = (YYSTYPE *) yymalloc (YYSTACKSIZE * sizeof (YYSTYPE));
        if (yyvs == 0)
        {
            yyfree (yyss);
            goto yyabort;
        }
        yystacksize = YYSTACKSIZE;
    }
    yysse = yyss + yystacksize - 1;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;
    goto yyloop;

yypush_lex:
    yyval = yylval;
    yystate = yytable[yyn];
yypush:
    if (yyssp >= yysse)
    {
        int depth = yyssp - yyss;
        if (yygrow() != 0)
             goto yyoverflow;
        yysse = yyss + yystacksize -1;
        yyssp = depth + yyss;
        yyvsp = depth + yyvs;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    yyn = yysindex[yystate];
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyerrflag > 0)  --yyerrflag;
        yychar = (-1);
        goto yypush_lex;
    }
    yyn = yyrindex[yystate];
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            yyn = yysindex[*yyssp];
            if (yyn != 0
                && ((yyn += YYERRCODE), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
                && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                goto yypush_lex;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 384 "parser.y"
{parse_error_occurred = 0; scanner_start_line (); }
break;
case 5:
#line 391 "parser.y"
{
			   this_line_labels =
			     cons_label (record_label ((char*)yyvsp[-1].p,
						       text_dir
						       ? current_text_pc ()
						       : current_data_pc (),
						       0),
					 this_line_labels);
				if (yyvsp[-1].p) free(yyvsp[-1].p);
			 }
break;
case 6:
#line 403 "parser.y"
{
		  label *l = record_label ((char*)yyvsp[-2].p, (mem_addr)yyvsp[0].i, 1);
		  if (yyvsp[-2].p) free(yyvsp[-2].p);

		  l->const_flag = 1;
		  clear_labels ();
		}
break;
case 7:
#line 414 "parser.y"
{
		  clear_labels ();
		}
break;
case 9:
#line 420 "parser.y"
{
		  clear_labels ();
		}
break;
case 12:
#line 430 "parser.y"
{
			LINE_PARSE_DONE;
		}
break;
case 13:
#line 435 "parser.y"
{
		  clear_labels ();
		  FILE_PARSE_DONE;
		}
break;
case 14:
#line 444 "parser.y"
{
		  i_type_inst (yyvsp[-2].i == Y_LD_POP ? Y_LW_OP : yyvsp[-2].i,
			       yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  if (yyvsp[-2].i == Y_LD_POP)
		    i_type_inst_free (Y_LW_OP,
				      yyvsp[-1].i + 1,
				      addr_expr_reg ((addr_expr *)yyvsp[0].p),
				      incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
							4));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 15:
#line 460 "parser.y"
{
		  i_type_inst (yyvsp[-2].i, yyvsp[-1].i, addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 16:
#line 468 "parser.y"
{
		  i_type_inst_free (yyvsp[-2].i, yyvsp[-1].i, 0, (imm_expr *)yyvsp[0].p);
		}
break;
case 17:
#line 474 "parser.y"
{
		  if (addr_expr_reg ((addr_expr *)yyvsp[0].p))
		    i_type_inst (Y_ADDI_OP, yyvsp[-1].i,
				 addr_expr_reg ((addr_expr *)yyvsp[0].p),
				 addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  else
		    i_type_inst (Y_ORI_OP, yyvsp[-1].i, 0,
				 addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 18:
#line 488 "parser.y"
{
		  i_type_inst_free (Y_ORI_OP, yyvsp[-1].i, 0, (imm_expr *)yyvsp[0].p);
		}
break;
case 19:
#line 494 "parser.y"
{
		  int *x = (int *) yyvsp[0].p;

		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*x));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1].i, 0, 1);
		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*(x+1)));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1].i + 1, 0, 1);
		}
break;
case 20:
#line 505 "parser.y"
{
		  float x = (float) *((double *) yyvsp[0].p);
		  int *y = (int *) &x;

		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*y));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1].i, 0, 1);
		}
break;
case 21:
#line 515 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst (Y_LWL_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  i_type_inst_free (Y_LWR_OP, yyvsp[-1].i,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      3));
#else
		  i_type_inst_free (Y_LWL_OP, yyvsp[-1].i,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      3));
		  i_type_inst (Y_LWR_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
#endif
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 22:
#line 539 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst ((yyvsp[-2].i == Y_ULH_POP ? Y_LB_OP : Y_LBU_OP),
			       yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  i_type_inst_free (Y_LBU_OP, 1,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      1));
#else
		  i_type_inst_free ((yyvsp[-2].i == Y_ULH_POP ? Y_LB_OP : Y_LBU_OP),
				    yyvsp[-1].i,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      1));
		  i_type_inst (Y_LBU_OP, 1,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
#endif
		  r_sh_type_inst (Y_SLL_OP, yyvsp[-1].i, yyvsp[-1].i, 8);
		  r_type_inst (Y_OR_OP, yyvsp[-1].i, yyvsp[-1].i, 1);
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 23:
#line 567 "parser.y"
{
		  i_type_inst (Y_LWC1_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  if (yyvsp[-2].i == Y_L_D_POP)
		    i_type_inst_free (Y_LWC1_OP, yyvsp[-1].i + 1,
				      addr_expr_reg ((addr_expr *)yyvsp[0].p),
				      incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
							4));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 24:
#line 582 "parser.y"
{
		  i_type_inst (yyvsp[-2].i == Y_SD_POP ? Y_SW_OP : yyvsp[-2].i,
			       yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  if (yyvsp[-2].i == Y_SD_POP)
		    i_type_inst_free (Y_SW_OP, yyvsp[-1].i + 1,
				      addr_expr_reg ((addr_expr *)yyvsp[0].p),
				      incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
							4));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 25:
#line 598 "parser.y"
{
		  i_type_inst (yyvsp[-2].i, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 26:
#line 608 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst (Y_SWL_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  i_type_inst_free (Y_SWR_OP, yyvsp[-1].i,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      3));
#else
		  i_type_inst_free (Y_SWL_OP, yyvsp[-1].i,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      3));
		  i_type_inst (Y_SWR_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
#endif
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 27:
#line 632 "parser.y"
{
		  i_type_inst (Y_SB_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  r_sh_type_inst (Y_SRL_OP, 1, yyvsp[-1].i, 8);
		  i_type_inst_free (Y_SB_OP, 1,
				    addr_expr_reg ((addr_expr *)yyvsp[0].p),
				    incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
						      1));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 28:
#line 647 "parser.y"
{
		  i_type_inst (Y_SWC1_OP, yyvsp[-1].i,
			       addr_expr_reg ((addr_expr *)yyvsp[0].p),
			       addr_expr_imm ((addr_expr *)yyvsp[0].p));
		  if (yyvsp[-2].i == Y_S_D_POP)
		    i_type_inst_free (Y_SWC1_OP, yyvsp[-1].i + 1,
				      addr_expr_reg ((addr_expr *)yyvsp[0].p),
				      incr_expr_offset (addr_expr_imm ((addr_expr *)yyvsp[0].p),
							4));
		  free (((addr_expr *)yyvsp[0].p)->imm);
		  free ((addr_expr *)yyvsp[0].p);
		}
break;
case 29:
#line 662 "parser.y"
{
		  r_type_inst (yyvsp[0].i, 0, 0, 0);
		}
break;
case 30:
#line 668 "parser.y"
{
		  if (yyvsp[0].i == 1)
		    yyerror ("Breakpoint 1 is reserved for debugger");
		  r_type_inst (yyvsp[-1].i, yyvsp[0].i, 0, 0);
		}
break;
case 31:
#line 676 "parser.y"
{
		  nop_inst ();
		}
break;
case 32:
#line 682 "parser.y"
{
		  if (yyvsp[-1].i != yyvsp[0].i)
		    r_type_inst (Y_ADDU_OP, yyvsp[-1].i, 0, yyvsp[0].i);

		  i_type_inst_free (Y_BGEZ_OP, 0, yyvsp[0].i, branch_offset (2));
		  r_type_inst (Y_SUB_OP, yyvsp[-1].i, 0, yyvsp[0].i);
		}
break;
case 33:
#line 692 "parser.y"
{
		  r_type_inst (Y_SUB_OP, yyvsp[-1].i, 0, yyvsp[0].i);
		}
break;
case 34:
#line 698 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, yyvsp[-1].i, 0, yyvsp[0].i);
		}
break;
case 35:
#line 704 "parser.y"
{
		  r_type_inst (Y_NOR_OP, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 36:
#line 710 "parser.y"
{
		  r_type_inst (Y_ADDU_OP, yyvsp[-1].i, 0, yyvsp[0].i);
		}
break;
case 37:
#line 716 "parser.y"
{
		  r_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 38:
#line 722 "parser.y"
{
		  i_type_inst_free (op_to_imm_op (yyvsp[-3].i), yyvsp[-2].i, yyvsp[-1].i,
				    (imm_expr *)yyvsp[0].p);
		}
break;
case 39:
#line 729 "parser.y"
{
		  i_type_inst_free (op_to_imm_op (yyvsp[-2].i), yyvsp[-1].i, yyvsp[-1].i,
				    (imm_expr *)yyvsp[0].p);
		}
break;
case 40:
#line 736 "parser.y"
{
		  r_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[0].i, yyvsp[-1].i);
		}
break;
case 41:
#line 742 "parser.y"
{
		  r_sh_type_inst (op_to_imm_op (yyvsp[-3].i), yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 42:
#line 748 "parser.y"
{
		  r_sh_type_inst (op_to_imm_op (yyvsp[-2].i), yyvsp[-1].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 43:
#line 754 "parser.y"
{
		  i_type_inst_free (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 44:
#line 760 "parser.y"
{
		  i_type_inst_free (yyvsp[-2].i, yyvsp[-1].i, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 45:
#line 765 "parser.y"
{
		  i_type_inst_free (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 46:
#line 771 "parser.y"
{
		  i_type_inst_free (yyvsp[-2].i, yyvsp[-1].i, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 47:
#line 777 "parser.y"
{
		  if ((yyvsp[0].i < 0) || (31 < yyvsp[0].i))
		    yywarn("Shift distance can only be in the range 0..31");
		  r_sh_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 48:
#line 785 "parser.y"
{
		  r_type_inst (imm_op_to_op (yyvsp[-3].i), yyvsp[-2].i, yyvsp[0].i, yyvsp[-1].i);
		}
break;
case 49:
#line 791 "parser.y"
{
		  r_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 50:
#line 797 "parser.y"
{
		  if (bare_machine && !accept_pseudo_insts)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    {
		      if (!zero_imm ((imm_expr *)yyvsp[0].p))
			/* Use $at */
			i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		      r_type_inst (yyvsp[-3].i,
				   yyvsp[-2].i,
				   yyvsp[-1].i,
				   (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		    }
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 51:
#line 815 "parser.y"
{
		  check_uimm_range ((imm_expr *)yyvsp[0].p, UIMM_MIN, UIMM_MAX);
		  if (bare_machine && !accept_pseudo_insts)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    {
		      if (!zero_imm ((imm_expr *)yyvsp[0].p))
			/* Use $at */
			i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		      r_type_inst (yyvsp[-2].i,
				   yyvsp[-1].i,
				   yyvsp[-1].i,
				   (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		    }
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 52:
#line 834 "parser.y"
{
		  r_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 53:
#line 840 "parser.y"
{
		  int val = eval_imm_expr ((imm_expr *)yyvsp[0].p);

		  if (bare_machine && !accept_pseudo_insts)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    i_type_inst (yyvsp[-3].i == Y_SUB_OP ? Y_ADDI_OP
				 : yyvsp[-3].i == Y_SUBU_OP ? Y_ADDIU_OP
				 : (fatal_error ("Bad SUB_OP\n"), 0),
				 yyvsp[-2].i,
				 yyvsp[-1].i,
				 make_imm_expr (-val, NULL, 0));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 54:
#line 857 "parser.y"
{
		  int val = eval_imm_expr ((imm_expr *)yyvsp[0].p);

		  if (bare_machine && !accept_pseudo_insts)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    i_type_inst (yyvsp[-2].i == Y_SUB_OP ? Y_ADDI_OP
				 : yyvsp[-2].i == Y_SUBU_OP ? Y_ADDIU_OP
				 : (fatal_error ("Bad SUB_OP\n"), 0),
				 yyvsp[-1].i,
				 yyvsp[-1].i,
				 make_imm_expr (-val, NULL, 0));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 55:
#line 874 "parser.y"
{
		  /* The hardware divide operation (ignore 1st arg) */
		  if (yyvsp[-2].i != Y_DIV_OP && yyvsp[-2].i != Y_DIVU_OP)
		    yyerror ("Syntax error");
		  r_type_inst (yyvsp[-2].i, 0, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 56:
#line 882 "parser.y"
{
		  /* Pseudo divide operations */
		  div_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 57:
#line 888 "parser.y"
{
		  if (zero_imm ((imm_expr *)yyvsp[0].p))
		    yyerror ("Divide by zero");
		  else
		    {
		      /* Use $at */
		      i_type_inst_free (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		      div_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, 1, 1);
		    }
		}
break;
case 58:
#line 901 "parser.y"
{
		  mult_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 59:
#line 906 "parser.y"
{
		  if (zero_imm ((imm_expr *)yyvsp[0].p))
		    /* Optimize: n * 0 == 0 */
		    i_type_inst_free (Y_ORI_OP, yyvsp[-2].i, 0, (imm_expr *)yyvsp[0].p);
		  else
		    {
		      /* Use $at */
		      i_type_inst_free (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		      mult_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, 1);
		    }
		}
break;
case 60:
#line 920 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, 0, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 61:
#line 926 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, 1, 0, yyvsp[0].i);
		  r_type_inst (Y_SLLV_OP, 1, 1, yyvsp[-1].i);
		  r_type_inst (Y_SRLV_OP, yyvsp[-2].i, yyvsp[0].i, yyvsp[-1].i);
		  r_type_inst (Y_OR_OP, yyvsp[-2].i, yyvsp[-2].i, 1);
		}
break;
case 62:
#line 935 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, 1, 0, yyvsp[0].i);
		  r_type_inst (Y_SRLV_OP, 1, 1, yyvsp[-1].i);
		  r_type_inst (Y_SLLV_OP, yyvsp[-2].i, yyvsp[0].i, yyvsp[-1].i);
		  r_type_inst (Y_OR_OP, yyvsp[-2].i, yyvsp[-2].i, 1);
		}
break;
case 63:
#line 944 "parser.y"
{
		  long dist = eval_imm_expr ((imm_expr *)yyvsp[0].p);

		  check_imm_range ((imm_expr *)yyvsp[0].p, 0, 31);
		  r_sh_type_inst (Y_SLL_OP, 1, yyvsp[-1].i, -dist);
		  r_sh_type_inst (Y_SRL_OP, yyvsp[-2].i, yyvsp[-1].i, dist);
		  r_type_inst (Y_OR_OP, yyvsp[-2].i, yyvsp[-2].i, 1);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 64:
#line 956 "parser.y"
{
		  long dist = eval_imm_expr ((imm_expr *)yyvsp[0].p);

		  check_imm_range ((imm_expr *)yyvsp[0].p, 0, 31);
		  r_sh_type_inst (Y_SRL_OP, 1, yyvsp[-1].i, -dist);
		  r_sh_type_inst (Y_SLL_OP, yyvsp[-2].i, yyvsp[-1].i, dist);
		  r_type_inst (Y_OR_OP, yyvsp[-2].i, yyvsp[-2].i, 1);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 65:
#line 969 "parser.y"
{
		  set_le_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 66:
#line 974 "parser.y"
{
		  if (!zero_imm ((imm_expr *)yyvsp[0].p))
		    /* Use $at */
		    i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		  set_le_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i,
			       (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 67:
#line 985 "parser.y"
{
		  set_gt_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 68:
#line 990 "parser.y"
{
		  if (!zero_imm ((imm_expr *)yyvsp[0].p))
		    /* Use $at */
		    i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		  set_gt_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i,
			       (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 69:
#line 1002 "parser.y"
{
		  set_ge_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 70:
#line 1007 "parser.y"
{
		  if (!zero_imm ((imm_expr *)yyvsp[0].p))
		    /* Use $at */
		    i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		  set_ge_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i,
			       (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 71:
#line 1018 "parser.y"
{
		  set_eq_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 72:
#line 1023 "parser.y"
{
		  if (!zero_imm ((imm_expr *)yyvsp[0].p))
		    /* Use $at */
		    i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[0].p);
		  set_eq_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i,
			       (zero_imm ((imm_expr *)yyvsp[0].p) ? 0 : 1));
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 73:
#line 1034 "parser.y"
{
		  i_type_inst_free (yyvsp[-1].i, 0, 0, (imm_expr *)yyvsp[0].p);
		}
break;
case 74:
#line 1040 "parser.y"
{
		  i_type_inst_free (yyvsp[-2].i, 0, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 75:
#line 1046 "parser.y"
{
		  i_type_inst_free (yyvsp[-2].i == Y_BEQZ_POP ? Y_BEQ_OP : Y_BNE_OP,
			       0, yyvsp[-1].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 76:
#line 1053 "parser.y"
{
		  i_type_inst_free (yyvsp[-3].i, yyvsp[-1].i, yyvsp[-2].i, (imm_expr *)yyvsp[0].p);
		}
break;
case 77:
#line 1058 "parser.y"
{
		  if (bare_machine && !accept_pseudo_insts)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    {
		      if (zero_imm ((imm_expr *)yyvsp[-1].p))
			i_type_inst (yyvsp[-3].i, yyvsp[-2].i,
				     (zero_imm ((imm_expr *)yyvsp[-1].p) ? 0 : 1),
				     (imm_expr *)yyvsp[0].p);
		      else
			{
			  /* Use $at */
			  i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[-1].p);
			  i_type_inst (yyvsp[-3].i, yyvsp[-2].i,
				       (zero_imm ((imm_expr *)yyvsp[-1].p) ? 0 : 1),
				       (imm_expr *)yyvsp[0].p);
			}
		    }
		  free ((imm_expr *)yyvsp[-1].p);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 78:
#line 1082 "parser.y"
{
		  r_type_inst (yyvsp[-3].i == Y_BGT_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-1].i, yyvsp[-2].i); /* Use $at */
		  i_type_inst_free (Y_BNE_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		}
break;
case 79:
#line 1089 "parser.y"
{
		  if (yyvsp[-3].i == Y_BGT_POP)
		    {
		      /* Use $at */
		      i_type_inst_free (Y_SLTI_OP, 1, yyvsp[-2].i,
					incr_expr_offset ((imm_expr *)yyvsp[-1].p, 1));
		      i_type_inst (Y_BEQ_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		    }
		  else
		    {
		      /* Use $at */
		      /* Can't add 1 to immediate since 0xffffffff+1 = 0 < 1 */
		      i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[-1].p);
		      i_type_inst_free (Y_BEQ_OP, yyvsp[-2].i, 1, branch_offset (3));
		      r_type_inst (Y_SLTU_OP, 1, yyvsp[-2].i, 1);
		      i_type_inst (Y_BEQ_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		    }
		  free ((imm_expr *)yyvsp[-1].p);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 80:
#line 1112 "parser.y"
{
		  r_type_inst (yyvsp[-3].i == Y_BGE_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-2].i, yyvsp[-1].i); /* Use $at */
		  i_type_inst_free (Y_BEQ_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		}
break;
case 81:
#line 1119 "parser.y"
{
		  i_type_inst (yyvsp[-3].i == Y_BGE_POP ? Y_SLTI_OP : Y_SLTIU_OP,
			       1, yyvsp[-2].i, (imm_expr *)yyvsp[-1].p); /* Use $at */
		  i_type_inst_free (Y_BEQ_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		  free ((imm_expr *)yyvsp[-1].p);
		}
break;
case 82:
#line 1128 "parser.y"
{
		  r_type_inst (yyvsp[-3].i == Y_BLT_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-2].i, yyvsp[-1].i); /* Use $at */
		  i_type_inst_free (Y_BNE_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		}
break;
case 83:
#line 1135 "parser.y"
{
		  i_type_inst (yyvsp[-3].i == Y_BLT_POP ? Y_SLTI_OP : Y_SLTIU_OP,
			       1, yyvsp[-2].i, (imm_expr *)yyvsp[-1].p); /* Use $at */
		  i_type_inst_free (Y_BNE_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		  free ((imm_expr *)yyvsp[-1].p);
		}
break;
case 84:
#line 1144 "parser.y"
{
		  r_type_inst (yyvsp[-3].i == Y_BLE_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-1].i, yyvsp[-2].i); /* Use $at */
		  i_type_inst_free (Y_BEQ_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		}
break;
case 85:
#line 1151 "parser.y"
{
		  if (yyvsp[-3].i == Y_BLE_POP)
		    {
		      /* Use $at */
		      i_type_inst_free (Y_SLTI_OP, 1, yyvsp[-2].i,
					incr_expr_offset ((imm_expr *)yyvsp[-1].p, 1));
		      i_type_inst (Y_BNE_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		    }
		  else
		    {
		      /* Use $at */
		      /* Can't add 1 to immediate since 0xffffffff+1 = 0 < 1 */
		      i_type_inst (Y_ORI_OP, 1, 0, (imm_expr *)yyvsp[-1].p);
		      i_type_inst (Y_BEQ_OP, yyvsp[-2].i, 1, (imm_expr *)yyvsp[0].p);
		      r_type_inst (Y_SLTU_OP, 1, yyvsp[-2].i, 1);
		      i_type_inst (Y_BNE_OP, 0, 1, (imm_expr *)yyvsp[0].p);
		    }
		  free ((imm_expr *)yyvsp[-1].p);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 86:
#line 1174 "parser.y"
{
		  if ((yyvsp[-1].i == Y_J_OP) || (yyvsp[-1].i == Y_JR_OP))
		    j_type_inst (Y_J_OP, (imm_expr *)yyvsp[0].p);
		  else if ((yyvsp[-1].i == Y_JAL_OP) || (yyvsp[-1].i == Y_JALR_OP))
		    j_type_inst (Y_JAL_OP, (imm_expr *)yyvsp[0].p);
		  free ((imm_expr *)yyvsp[0].p);
		}
break;
case 87:
#line 1184 "parser.y"
{
		  if ((yyvsp[-1].i == Y_J_OP) || (yyvsp[-1].i == Y_JR_OP))
		    r_type_inst (Y_JR_OP, 0, yyvsp[0].i, 0);
		  else if ((yyvsp[-1].i == Y_JAL_OP) || (yyvsp[-1].i == Y_JALR_OP))
		    r_type_inst (Y_JALR_OP, 31, yyvsp[0].i, 0);
		}
break;
case 88:
#line 1193 "parser.y"
{
		  if ((yyvsp[-2].i == Y_J_OP) || (yyvsp[-2].i == Y_JR_OP))
		    r_type_inst (Y_JR_OP, 0, yyvsp[0].i, 0);
		  else if ((yyvsp[-2].i == Y_JAL_OP) || (yyvsp[-2].i == Y_JALR_OP))
		    r_type_inst (Y_JALR_OP, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 89:
#line 1202 "parser.y"
{
		/* GIAN */
		  i_type_inst_free ((yyvsp[-1].i == Y_BAL_POP ? Y_BGEZAL_OP : Y_BEQ_OP),
				    0, 0, (imm_expr *)yyvsp[0].p);
		}
break;
case 91:
#line 1212 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 92:
#line 1218 "parser.y"
{
		  r_type_inst (yyvsp[-1].i, yyvsp[0].i, 0, 0);
		}
break;
case 93:
#line 1224 "parser.y"
{
		  r_type_inst (yyvsp[-1].i, 0, yyvsp[0].i, 0);
		}
break;
case 94:
#line 1230 "parser.y"
{
		  if (yyvsp[-2].i == Y_MFC1_D_POP)
		    {
		      r_type_inst (Y_MFC1_OP, yyvsp[0].i, 0, yyvsp[-1].i);
		      r_type_inst (Y_MFC1_OP, yyvsp[0].i + 1, 0, yyvsp[-1].i + 1);
		    }
		  else if (yyvsp[-2].i == Y_MTC1_D_POP)
		    {
		      r_type_inst (Y_MTC1_OP, yyvsp[0].i, 0, yyvsp[-1].i);
		      r_type_inst (Y_MTC1_OP, yyvsp[0].i + 1, 0, yyvsp[-1].i + 1);
		    }
		  else
		    r_type_inst (yyvsp[-2].i, yyvsp[0].i, 0, yyvsp[-1].i);
		}
break;
case 95:
#line 1247 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, yyvsp[0].i, 0, yyvsp[-1].i);
		}
break;
case 96:
#line 1253 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 97:
#line 1259 "parser.y"
{
		  r_type_inst (yyvsp[-3].i, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 98:
#line 1265 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 99:
#line 1271 "parser.y"
{
		  r_type_inst (yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i, 0);
		}
break;
case 100:
#line 1277 "parser.y"
{
		  r_cond_type_inst (yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i);
		}
break;
case 280:
#line 1556 "parser.y"
{
		  align_data (yyvsp[0].i);
		}
break;
case 281:
#line 1560 "parser.y"
{null_term = 0;}
break;
case 282:
#line 1561 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 283:
#line 1566 "parser.y"
{null_term = 1;}
break;
case 284:
#line 1567 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 287:
#line 1579 "parser.y"
{store_op = store_byte;}
break;
case 288:
#line 1581 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 289:
#line 1588 "parser.y"
{
		  align_data (2);
		  if (lookup_label ((char*)yyvsp[-1].p)->addr == 0)
		  {
		    record_label ((char*)yyvsp[-1].p, current_data_pc (), 1);
			if (yyvsp[-2].p) free(yyvsp[-2].p);
		  }
		  increment_data_pc (yyvsp[0].i);
		}
break;
case 290:
#line 1600 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 291:
#line 1607 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		  set_data_pc (yyvsp[0].i);
		}
break;
case 292:
#line 1616 "parser.y"
{
		  user_kernel_data_segment (1);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 293:
#line 1623 "parser.y"
{
		  user_kernel_data_segment (1);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		  set_data_pc (yyvsp[0].i);
		}
break;
case 294:
#line 1632 "parser.y"
{
		  store_op = store_double;
		  if (data_dir) set_data_alignment(3);
		}
break;
case 295:
#line 1637 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 301:
#line 1655 "parser.y"
{
		  extern_directive ((char*)yyvsp[-1].p, yyvsp[0].i);
		}
break;
case 302:
#line 1661 "parser.y"
{
		  fatal_error ("File contains an .err directive\n");
		}
break;
case 304:
#line 1670 "parser.y"
{
		  store_op = store_float;
		  if (data_dir) set_data_alignment (2);
		}
break;
case 305:
#line 1675 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 308:
#line 1687 "parser.y"
{
		  make_label_global ((char*)yyvsp[0].p);
		  if (yyvsp[0].p) free(yyvsp[0].p);
		}
break;
case 309:
#line 1694 "parser.y"
{
		  store_op = store_half;
		  if (data_dir) set_data_alignment (1);
		}
break;
case 310:
#line 1699 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 311:
#line 1706 "parser.y"
{
		  record_label ((char*)yyvsp[0].p,
				text_dir
				? current_text_pc ()
				: current_data_pc (),
				1);
		  if (yyvsp[-1].p) free(yyvsp[-1].p);
		}
break;
case 312:
#line 1717 "parser.y"
{
		  lcomm_directive ((char*)yyvsp[-1].p, yyvsp[0].i);
		}
break;
case 318:
#line 1735 "parser.y"
{
		  yyerror ("Warning: repeat directive ignored");
		}
break;
case 319:
#line 1741 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 320:
#line 1748 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		  set_data_pc (yyvsp[0].i);
		}
break;
case 321:
#line 1757 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 322:
#line 1764 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		  set_data_pc (yyvsp[0].i);
		}
break;
case 323:
#line 1773 "parser.y"
{
		  if (streq ((char*)yyvsp[0].p, "noat"))
		    noat_flag = 1;
		  else if (streq ((char*)yyvsp[0].p, "at"))
		    noat_flag = 0;
		}
break;
case 324:
#line 1782 "parser.y"
{
		  if (data_dir)
		    increment_data_pc (yyvsp[0].i);
		  else if (text_dir)
		    increment_text_pc (yyvsp[0].i);
		}
break;
case 325:
#line 1791 "parser.y"
{
		  yyerror ("Warning: struct directive ignored");
		}
break;
case 326:
#line 1797 "parser.y"
{
		  user_kernel_text_segment (0);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		}
break;
case 327:
#line 1804 "parser.y"
{
		  user_kernel_text_segment (0);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		  set_text_pc (yyvsp[0].i);
		}
break;
case 328:
#line 1813 "parser.y"
{
		  user_kernel_text_segment (1);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		}
break;
case 329:
#line 1820 "parser.y"
{
		  user_kernel_text_segment (1);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		  set_text_pc (yyvsp[0].i);
		}
break;
case 332:
#line 1834 "parser.y"
{
		  store_op = store_word_data;
		  if (data_dir) set_data_alignment (2);
		}
break;
case 334:
#line 1844 "parser.y"
{only_id = 1;}
break;
case 335:
#line 1844 "parser.y"
{only_id = 0; yyval = yyvsp[0];}
break;
case 336:
#line 1847 "parser.y"
{
		  yyval.p = make_addr_expr (0, NULL, yyvsp[-1].i);
		}
break;
case 337:
#line 1852 "parser.y"
{
		  yyval.p = make_addr_expr (yyvsp[0].i, NULL, 0);
		}
break;
case 338:
#line 1857 "parser.y"
{
		  yyval.p = make_addr_expr (yyvsp[-3].i, NULL, yyvsp[-1].i);
		}
break;
case 339:
#line 1862 "parser.y"
{
		  yyval.p = make_addr_expr (0, (char*)yyvsp[0].p, 0);
		  if (yyvsp[0].p) free ((char*)yyvsp[0].p);
		}
break;
case 340:
#line 1868 "parser.y"
{
		  yyval.p = make_addr_expr (0, (char*)yyvsp[-3].p, yyvsp[-1].i);
		  if (yyvsp[-3].p) free ((char*)yyvsp[-3].p);
		}
break;
case 341:
#line 1874 "parser.y"
{
		  yyval.p = make_addr_expr (yyvsp[0].i, (char*)yyvsp[-2].p, 0);
		  if (yyvsp[-2].p) free ((char*)yyvsp[-2].p);
		}
break;
case 342:
#line 1880 "parser.y"
{
		  yyval.p = make_addr_expr (yyvsp[-2].i, (char*)yyvsp[0].p, 0);
		}
break;
case 343:
#line 1885 "parser.y"
{
		  yyval.p = make_addr_expr (- yyvsp[0].i, (char*)yyvsp[-2].p, 0);
		  if (yyvsp[-2].p) free ((char*)yyvsp[-2].p);
		}
break;
case 344:
#line 1891 "parser.y"
{
		  yyval.p = make_addr_expr (yyvsp[-3].i, (char*)yyvsp[-5].p, yyvsp[-1].i);
		  if (yyvsp[-5].p) free ((char*)yyvsp[-5].p);
		}
break;
case 345:
#line 1897 "parser.y"
{
		  yyval.p = make_addr_expr (- yyvsp[-3].i, (char*)yyvsp[-5].p, yyvsp[-1].i);
		  if (yyvsp[-5].p) free ((char*)yyvsp[-5].p);
		}
break;
case 346:
#line 1904 "parser.y"
{only_id = 1;}
break;
case 347:
#line 1904 "parser.y"
{only_id = 0; yyval = yyvsp[0];}
break;
case 348:
#line 1907 "parser.y"
{
		  check_imm_range(yyvsp[0].p, IMM_MIN, IMM_MAX);
		  yyval = yyvsp[0];
		}
break;
case 349:
#line 1913 "parser.y"
{
		  check_uimm_range(yyvsp[0].p, UIMM_MIN, UIMM_MAX);
		  yyval = yyvsp[0];
		}
break;
case 350:
#line 1920 "parser.y"
{
		  yyval.p = make_imm_expr (yyvsp[0].i, NULL, 0);
		}
break;
case 351:
#line 1925 "parser.y"
{
		  yyval.p = make_imm_expr (yyvsp[-4].i >> yyvsp[0].i, NULL, 0);
		}
break;
case 352:
#line 1930 "parser.y"
{
		  yyval.p = make_imm_expr (0, (char*)yyvsp[0].p, 0);
		}
break;
case 353:
#line 1935 "parser.y"
{
		  yyval.p = make_imm_expr (yyvsp[0].i, (char*)yyvsp[-2].p, 0);
		  free ((char*)yyvsp[-2].p);
		}
break;
case 354:
#line 1941 "parser.y"
{
		  yyval.p = make_imm_expr (- yyvsp[0].i, (char*)yyvsp[-2].p, 0);
		  free ((char*)yyvsp[-2].p);
		}
break;
case 356:
#line 1951 "parser.y"
{yyval.i = yyvsp[-2].i + yyvsp[0].i;}
break;
case 357:
#line 1954 "parser.y"
{
		  /* Y_INT '-' Y_INT */
		  if (yyvsp[0].i >= 0)
		    yyerror ("Syntax error");
		  yyval.i = yyvsp[-1].i - yyvsp[0].i;
		}
break;
case 364:
#line 1975 "parser.y"
{
		  if (yyvsp[0].i < 0 || yyvsp[0].i > 31)
		    yyerror ("Register number out of range");
		  if (yyvsp[0].i == 1 && !bare_machine && !noat_flag)
		    yyerror ("Register 1 is reserved for assembler");
		  yyval = yyvsp[0];
		}
break;
case 368:
#line 1990 "parser.y"
{
		  if (yyvsp[0].i < 0 || yyvsp[0].i > 31)
		    yyerror ("FP register number out of range");
		  yyval = yyvsp[0];
		}
break;
case 371:
#line 2005 "parser.y"
{
		  yyval.p = make_imm_expr (-(int)current_text_pc (), (char*)yyvsp[0].p, 1);
		}
break;
case 374:
#line 2016 "parser.y"
{
		  store_string ((char*)yyvsp[0].p, y_str_length, null_term);
		  free ((char*)yyvsp[0].p);
		}
break;
case 375:
#line 2021 "parser.y"
{
		  int i;

		  for (i = 0; i < yyvsp[0].i; i ++)
		    store_string ((char*)yyvsp[-2].p, y_str_length, null_term);
		  free ((char*)yyvsp[-2].p);
		}
break;
case 376:
#line 2031 "parser.y"
{only_id = 1;}
break;
case 377:
#line 2031 "parser.y"
{only_id = 0; yyval = yyvsp[0];}
break;
case 379:
#line 2036 "parser.y"
{
		  label *l = lookup_label ((char*)yyvsp[0].p);

		  if (l->addr == 0)
		    {
		      record_data_uses_symbol (current_data_pc (), l);
		      yyval.p = NULL;
		    }
		  else
		    yyval.i = l->addr;
		}
break;
case 380:
#line 2050 "parser.y"
{
		  store_op (yyvsp[0].p);
		}
break;
case 381:
#line 2054 "parser.y"
{
		  store_op (yyvsp[0].p);
		}
break;
case 382:
#line 2058 "parser.y"
{
		  int i;

		  for (i = 0; i < yyvsp[0].i; i ++)
		    store_op (yyvsp[-2].p);
		}
break;
case 383:
#line 2068 "parser.y"
{
		  store_op (yyvsp[0].p);
		}
break;
case 384:
#line 2072 "parser.y"
{
		  store_op (yyvsp[0].p);
		}
break;
case 385:
#line 2078 "parser.y"
{only_id = 1;}
break;
case 386:
#line 2078 "parser.y"
{only_id = 0; yyval = yyvsp[0];}
break;
case 388:
#line 2081 "parser.y"
{yyval.p = (void*)NULL;}
break;
case 389:
#line 2085 "parser.y"
{only_id = 1;}
break;
case 390:
#line 2085 "parser.y"
{only_id = 0; yyval = yyvsp[0];}
break;
#line 3361 "y.tab.c"
    }
    yyssp -= yym;
    yyvsp -= yym;
    yym = yylhs[yyn];
    yystate = *yyssp;
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    yyn = yygindex[yym];
	 if (yyn != 0
        && ((yyn += yystate), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    goto yypush;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
